<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Login extends CI_Controller {
	
	function __construct()
	{
		parent::__construct();
		date_default_timezone_set("Asia/Kolkata");
		$this->load->library(array('form_validation', 'session'));
		$this->load->helper('url','form','HTML');
		//$this->load->library('Notifications');
		//$this->is_logged_in();
		$this->load->model('hospital_admin/loginmodel');
		$this->db->query('SET SESSION sql_mode =
                  REPLACE(REPLACE(REPLACE(
                  @@sql_mode,
                  "ONLY_FULL_GROUP_BY,", ""),
                  ",ONLY_FULL_GROUP_BY", ""),
                  "ONLY_FULL_GROUP_BY", "")'); 
	}
	
/*login*/
public function index(){
	$this->load->view('hospitals/login');
}
public function send_otp(){
    $mobile = $this->input->post('mobile');

    if (!preg_match('/^[0-9]{10}$/', $mobile)) {
        echo json_encode(['success' => false, 'message' => 'Invalid mobile number']);
        return;
    }
    
    $check_login = $this->loginmodel->common_fetch('main_data',['mobile' => $mobile,'delete_status' => 1]);
    
    if(empty($check_login)){
        echo json_encode(['success' => false, 'message' => 'Please check the entered mobile number']);
        return;
    }else{
        if($check_login[0]['status']==0){
            echo json_encode(['success' => false, 'message' => 'Your account is inactive']);
            return;
        }else{
            // Generate a random 4 or 6-digit OTP
            $otp = rand(1000, 9999);
        
            // Store OTP in session or database
            $this->session->set_userdata('otp', $otp);
        
            // Simulate OTP sending (Replace this with an actual SMS API)
            // Example: $this->send_sms($mobile, "Your OTP is $otp");
        
            echo json_encode(['success' => true, 'message' => "OTP sent successfully! : $otp"]);
            return;       
        }
    }
}
public function check_login(){
    $otp_session = $this->session->userdata('otp');
	$data = array(
        'mobile'   		=> $_POST['mobile'],
		'otp'   	    => $_POST['otp']
	);
	//print_r($data);exit;
	$check_login = $this->loginmodel->common_fetch('main_data',['mobile' => $data['mobile'],'delete_status' => 1]);
	if(!empty($check_login)){
	    if($check_login[0]['status']==0){
	        echo json_encode(['success' => false, 'message' => 'Your account is inactive']);
            return;
	    }else{
    		if($otp_session==$data['otp']){
    		    $this->session->set_userdata('user_info',array('user_id' => $check_login[0]['id'],'is_logged_in' => TRUE,'name' => $check_login[0]['name']));
                echo json_encode(['success' => true, 'message' => "User logged in successfully"]);
                return;
    		}else{
    		   echo json_encode(['success' => false, 'message' => "Please check the entered otp"]);
               return; 
    		}
	    }
	}else{
		echo json_encode(['success' => false, 'message' => "Please check the entered mobile number"]);
        return;
	}
}

public function logout(){
	$this->session->unset_userdata('is_logged_in');
    $this->session->sess_destroy();
    return redirect('hospital_admin/login');
}
/*login*/

}
?>