<?php
class Registermodel extends CI_Model{
/*default functions*/
public function common_fetch($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_asc($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','asc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_rows($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->num_rows();
}
public function common_insert($table,$data){
	$this->db->insert($table,$data);
	$id = $this->db->insert_id();
	return $id;
}
public function common_update($table,$data,$where){
	$this->db->where($where);
	$this->db->update($table,$data);
}
public function common_delete($table,$where){
	$this->db->where($where);
	$this->db->delete($table);
}
/*default functions*/

/*public_relation_agents*/
public function get_public_relation_agents($sess_data,$limit,$start,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->group_end();
    }
    $this->db->limit($limit,$start);
    $query = $this->db->get('pr_agents');
    return $query->result_array();
}
public function get_public_relation_agents_count($sess_data,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->group_end();
    }
    $query = $this->db->get('pr_agents');
    return $query->num_rows();
}
/*public_relation_agents*/

/*ambulances*/
public function get_ambulances($sess_data,$limit,$start,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->or_like('vehicle_number',$search);
        $this->db->or_like('driver_status',$search);
        $this->db->group_end();
    }
    $this->db->limit($limit,$start);
    $query = $this->db->get('ambulance_drivers');
    return $query->result_array();
}
public function get_ambulances_count($sess_data,$search){
    $this->db->where(['main_data_id' => $sess_data,'delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('name',$search);
        $this->db->or_like('mobile',$search);
        $this->db->or_like('vehicle_number',$search);
        $this->db->or_like('driver_status',$search);
        $this->db->group_end();
    }
    $query = $this->db->get('ambulance_drivers');
    return $query->num_rows();
}
/*ambulances*/

/*doctors*/
public function get_doctors($sess_data, $limit, $start, $search) {
    $this->db->select('doctors.*, specialities.name AS speciality, GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification');
    $this->db->from('doctors');
    
    // JOINs
    $this->db->join('specialities', 'specialities.id = doctors.speciality_id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, doctors.qualification)', 'left');
    
    // WHERE conditions
    $this->db->where([
        'doctors.main_data_id' => $sess_data,
        'doctors.delete_status' => 1
    ]);
    
    // Search filters
    if (!empty($search)) {
        $this->db->group_start();
        $this->db->like('doctors.name', $search);
        $this->db->or_like('specialities.name', $search);
        $this->db->or_like('doctors.consult_type', $search);
        $this->db->group_end();
    }

    // GROUP BY required due to GROUP_CONCAT
    $this->db->group_by('doctors.id');

    // Pagination
    $this->db->limit($limit, $start);

    // Execute query
    $query = $this->db->get();
    return $query->result_array();
}
public function get_doctors_count($sess_data,$search){
    $this->db->select('doctors.*,specialities.name as speciality')->from('doctors');
    $this->db->where(['doctors.main_data_id' => $sess_data,'doctors.delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('doctors.name',$search);
        $this->db->or_like('specialities.name',$search);
        $this->db->or_like('doctors.consult_type',$search);
        $this->db->group_end();
    }
    $this->db->join('specialities','specialities.id=doctors.speciality_id','left');
    $query = $this->db->get();
    return $query->num_rows();
}
public function main_data_specialities($sess_data){
    $this->db->select('mds.id,mds.speciality_id,mds.main_data_id,s.name')->from('main_data_specialities mds');
    $this->db->where(['mds.main_data_id' => $sess_data,'mds.status' => 1,'mds.delete_status' =>1]);
    $this->db->join('specialities s','s.id=mds.speciality_id','left');
    $this->db->order_by('mds.id','desc');
    $query = $this->db->get();
    return $query->result_array();
}
public function get_doctor_slots($sess_data, $limit, $start, $search) {
    $this->db->select('doctor_slots.date, doctors.name, doctor_slots.id, doctor_slots.doctor_id,doctor_slots.created_on,doctor_slots.modified_on')
             ->from('doctor_slots')
             ->where(['doctor_slots.main_data_id' => $sess_data, 'doctor_slots.delete_status' => 1]);

    if (!empty($search)) {
        $this->db->group_start();
        $this->db->like('doctors.name', $search);
        $this->db->or_like('doctor_slots.date', $search);
        $this->db->group_end();
    }

    $this->db->join('doctors', 'doctors.id = doctor_slots.doctor_id AND doctors.status = 1 AND doctors.delete_status = 1', 'left');
    $this->db->group_by(['doctor_slots.date', 'doctor_slots.doctor_id']); // Grouping by date & doctor_id
    $this->db->limit($limit, $start);

    $query = $this->db->get();
    return $query->result_array();
}
public function get_doctor_slots_count($sess_data,$search){
    $this->db->select('doctor_slots.date, doctors.name, doctor_slots.id, doctor_slots.doctor_id,doctor_slots.created_on,doctor_slots.modified_on')
             ->from('doctor_slots')
             ->where(['doctor_slots.main_data_id' => $sess_data, 'doctor_slots.delete_status' => 1]);

    if (!empty($search)) {
        $this->db->group_start();
        $this->db->like('doctors.name', $search);
        $this->db->or_like('doctor_slots.date', $search);
        $this->db->group_end();
    }

    $this->db->join('doctors', 'doctors.id = doctor_slots.doctor_id AND doctors.status = 1 AND doctors.delete_status = 1', 'left');
    $this->db->group_by(['doctor_slots.date', 'doctor_slots.doctor_id']); // Grouping by date & doctor_id

    $query = $this->db->get();
    return $query->num_rows();
}
/*doctors*/

/*pharmacy*/
public function get_pharmacy($sess_data,$limit,$start,$search){
    $this->db->select('hpp.*,pc.name as category')->from('hospital_pharmacy_products hpp');
    $this->db->where(['hpp.main_data_id' => $sess_data,'hpp.delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('hpp.name',$search);
        $this->db->or_like('pc.name',$search);
        $this->db->group_end();
    }
    $this->db->join('pharmacy_categories pc','pc.id=hpp.cat_id','left');
    $this->db->limit($limit,$start);
    $query = $this->db->get();
    return $query->result_array();
}
public function get_pharmacy_count($sess_data,$search){
    $this->db->select('hpp.*,pc.name as category')->from('hospital_pharmacy_products hpp');
    $this->db->where(['hpp.main_data_id' => $sess_data,'hpp.delete_status' => 1]);
    if(!empty($search)){
        $this->db->group_start();
        $this->db->like('hpp.name',$search);
        $this->db->or_like('pc.name',$search);
        $this->db->group_end();
    }
    $this->db->join('pharmacy_categories pc','pc.id=hpp.cat_id','left');
    $query = $this->db->get();
    return $query->num_rows();
}
/*pharmacy*/

}
?>