<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ws_model extends CI_Model{

/*default functions*/
public function common_fetch($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_select($table, $where = [], $select = '*', $integerFields = []) {
    $this->db->select($select);
    $this->db->from($table);
    
    if (!empty($where)) {
        $this->db->where($where);
    }
    $this->db->order_by('id','desc');
    $query = $this->db->get();
    
    if ($query->num_rows() > 0) {
        $result = $query->result_array();
        
        // Type-cast requested fields to integer
        if (!empty($integerFields)) {
            foreach ($result as &$row) {
                foreach ($integerFields as $field) {
                    if (isset($row[$field])) {
                        $row[$field] = (int) $row[$field];
                    }
                }
            }
            unset($row);
        }
        
        return $result;
    } else {
        return [];
    }
}
public function common_fetch_asc($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','asc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_insert($table,$data){	
	$this->db->insert($table,$data);
	$id = $this->db->insert_id();
	return $id;
}
public function common_update($table,$data,$where){
	$this->db->where($where);
	$this->db->update($table,$data);
}
public function common_delete($table,$where){
	$this->db->where($where);
	$this->db->delete($table);
}
public function common_fetch_rows($table,$where){
	$this->db->where($where);	
	$query = $this->db->get($table);
	return $query->num_rows();
}
// In your Ws_model.php
public function is_exists($table, $where = []) {
    $this->db->from($table);
    if (!empty($where)) {
        $this->db->where($where);
    }
    $query = $this->db->limit(1)->get();
    return $query->num_rows() > 0;
}

/*default functions*/

/*home_page*/
public function doctor_bookings_history_active($user_id, $limit, $offset) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile,b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, s.name AS speciality_name, d.name AS doctor_name, fm.email, fm.gender, fm.dob, fm.image, bg.name as blood_group');

    $this->db->from('doctor_bookings b');
    $this->db->join('specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');

    // Filter active bookings for the doctor
    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'booked');

    // Avoid duplicates in case of joins
    $this->db->group_by('b.id');

    // Custom ordering: today's bookings first, then older dates
    $today = date('Y-m-d');
    $this->db->order_by("CASE 
        WHEN b.date = '{$today}' THEN 0 
        ELSE 1 
    END", "ASC"); // Today comes first
    $this->db->order_by('b.date', 'DESC'); // Then remaining in descending order

    // Pagination
    $this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    // Format and return result
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'speciality_name'   => $row['speciality_name'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group']
        ];
    }, $result);
}
public function doctor_bookings_history_active_rows($user_id) {
    $this->db->from('doctor_bookings b');
    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'booked');
    return $this->db->count_all_results();
}
/*public function get_doctor_slots($user_id, $date) {
    $today = date('Y-m-d');
    $current_time = date('h:i A'); // Current time in 12-hour format (e.g., 03:20 PM)

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('doctor_slots');
    $this->db->where('doctor_id', $user_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // If the selected date is today, only show slots after the current time
    if ($date == $today) {
        // Convert current time to 24-hour format for comparison
        $current_time_24hr = date('H:i', strtotime($current_time)); // Convert current time to 24-hour format

        // Use the correct comparison to filter slots after the current time
        $this->db->where('time >=', $current_time);
    }

    $this->db->order_by('time', 'ASC');

    $query = $this->db->get();
    $results = $query->result_array();

    // Group slots by session (morning, afternoon, evening)
    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    foreach ($results as $row) {
        $row['id'] = intval($row['id']); // Convert slot ID to int
        $row['format_date'] = date('d M Y', strtotime($row['date']));
        
        // Convert the time from 12-hour format to 24-hour format for comparison
        $slot_time_24hr = date('H:i', strtotime($row['time'])); // Convert slot time to 24-hour format

        // If today, filter slots before the current time
        if ($date == $today && $slot_time_24hr < $current_time_24hr) {
            continue; // Skip slots that are in the past if today
        }

        // Add the slot to the appropriate session (morning, afternoon, evening)
        if ($slot_time_24hr >= '06:00' && $slot_time_24hr < '12:00') {
            $slots['morning'][] = $row;
        } elseif ($slot_time_24hr >= '12:00' && $slot_time_24hr < '16:00') {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    return [
        'slots' => $slots
    ];
}*/
public function get_doctor_slots($user_id, $date) {
    $today = date('Y-m-d');
    $current_time = date('H:i'); // current time in 24-hour format

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('doctor_slots');
    $this->db->where('doctor_id', $user_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // If today, filter out past time slots (we do this in PHP after query)
    $this->db->order_by('id', 'ASC'); // Use ID or leave unordered (will sort in PHP)

    $query = $this->db->get();
    $results = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];

    foreach ($results as $row) {
        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        // Convert time (12-hour) to 24-hour for sorting & filtering
        $slot_time_24hr = date('H:i', strtotime($row['time']));

        // Filter out past slots for today's date
        if ($date == $today && $slot_time_24hr < $current_time) {
            continue;
        }

        // Assign session
        if ($slot_time_24hr >= '05:00' && $slot_time_24hr < '12:00') {
            $slots['morning'][] = $row;
        } elseif ($slot_time_24hr >= '12:00' && $slot_time_24hr < '16:00') {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    // Sort each session manually by slot time
    foreach ($slots as &$session) {
        usort($session, function ($a, $b) {
            return strtotime($a['time']) - strtotime($b['time']);
        });
    }

    return ['slots' => $slots];
}
public function prescription_preview_doctor_details($doctor_id){
    $this->db->select('doctors.*, COUNT(doctor_bookings.id) AS consultations, GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification,odc.name as specialization ')->from('doctors');
    $this->db->where('doctors.id',$doctor_id);
    $this->db->join('doctor_bookings', 'doctor_bookings.doctor_id = doctors.id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, doctors.qualification)', 'left');
    $this->db->join('specialities odc', 'odc.id = doctors.speciality_id', 'left');
    $query = $this->db->get();
    $result = $query->result_array();
    // Map data
    return array_map(function ($row) {
        
        return [
            'id'                => intval($row['id']),
            'unique_id'         => $row['unique_id'],
            'speciality_id'     => intval($row['speciality_id']),
            'name'              => $row['name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => intval($row['exp']),
            //'description'       => $row['description'],
            //'fee'               => intval($row['fee']),
            'consultations'     => intval($row['consultations'])
        ];
    }, $result);
}
/*home_page*/

/*hamburger*/
public function get_doctor_booked_slots($doctor_id,$date) {
    $this->db->select('id as slot_id, time, date, booking_status');
    $this->db->from('doctor_slots');
    $this->db->where('doctor_id', $doctor_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1); // Ensure only active slots are fetched
    $this->db->where('delete_status', 1); // Ensure only non-deleted slots are fetched

    $results = $this->db->get()->result_array();

    // Normalize time format
    foreach ($results as &$row) {
        $row['time'] = date('h:i A', strtotime($row['time']));
    }

    return $results;
}
public function doctor_bookings_history_completed($user_id, $limit, $offset) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, s.name AS speciality_name, d.name AS doctor_name, fm.email, fm.gender, fm.dob, fm.image,bg.name as blood_group');

    $this->db->from('doctor_bookings b');
    $this->db->join('specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');

    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    $this->db->group_by('b.id');
    $this->db->order_by('b.id', 'DESC');
    $this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    $final_result = [];

    foreach ($result as $row) {
        $booking_id = $row['booking_id'];

        // Fetch medicines
        $medicines = $this->db->get_where('doctor_booking_medicines', ['booking_id' => $booking_id])->result_array();

        // Fetch notes
        $notes = $this->db->get_where('doctor_booking_notes', ['booking_id' => $booking_id])->result_array();

        // Fetch tests
        $tests = $this->db->get_where('doctor_booking_tests', ['booking_id' => $booking_id])->result_array();

        $final_result[] = [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'speciality_name'   => $row['speciality_name'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group'],
            'medicines'         => !empty($medicines) ? $medicines : [],
            'notes'             => !empty($notes) ? $notes : [],
            'tests'             => !empty($tests) ? $tests : [],
        ];
    }

    return $final_result;
}
public function doctor_bookings_history_completed_rows($user_id) {
    $this->db->from('doctor_bookings b');
    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    return $this->db->count_all_results();
}
public function doctor_single_booking_history_completed($booking_id) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, b.booking_status,s.name AS specialization, d.name AS doctor_name, GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification, fm.email, fm.gender, fm.dob, fm.image, bg.name as blood_group');

    $this->db->from('doctor_bookings b');
    $this->db->join('specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    $this->db->where('b.booking_id', $booking_id);
    //$this->db->where('b.booking_status', 'completed');
    $this->db->group_by('b.id');
    $this->db->order_by('b.id', 'DESC');
    //$this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    $final_result = [];

    foreach ($result as $row) {
        $booking_id = $row['booking_id'];

        // Fetch medicines
        $medicines = $this->db
        ->select('medicine, medicine_time')
        ->get_where('doctor_booking_medicines', ['booking_id' => $booking_id])
        ->result_array();

        
        // Fetch tests
        $tests = $this->db
        ->select('test, test_instruction')
        ->get_where('doctor_booking_tests', ['booking_id' => $booking_id])
        ->result_array();
        
        // Fetch notes
        
        $notes = $this->db
            ->select('notes')
            ->get_where('doctor_booking_notes', ['booking_id' => $booking_id])
            ->result_array();
        
        // Extract just the 'notes' values into a simple array
        $note_values = array_column($notes, 'notes');
        
        // Assign directly to your output array
        $data = $note_values;

        $final_result[] = [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'specialization'    => $row['specialization'],
            'name'              => $row['doctor_name'],
            'qualification'     => $row['qualification'],
            'image'             => $row['image'],
            'booking_status'    => $row['booking_status'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group'],
            'medicines'         => !empty($medicines) ? $medicines : [],
            'tests'             => !empty($tests) ? $tests : [],
            'notes'             => !empty($notes) ? $data : []
        ];
    }

    return $final_result;
}
public function doctor_profile($user_id){
    $this->db->select('doctors.id,doctors.unique_id,doctors.speciality_id,doctors.name,doctors.mobile,doctors.image,doctors.exp,doctors.description,doctors.consult_type,doctors.online_fee,doctors.offline_fee,specialities.name as specialization,GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification')->from('doctors');
    $this->db->where('doctors.id',$user_id);
    $this->db->join('specialities','specialities.id=doctors.speciality_id','left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, doctors.qualification)', 'left');
    $this->db->group_by('doctors.id');
    $query = $this->db->get();
    $result = $query->result_array();
    // Map data
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'unique_id'         => $row['unique_id'],
            'speciality_id'     => intval($row['speciality_id']),
            'name'              => $row['name'],
            'mobile'            => intval($row['mobile']),
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => intval($row['exp']),
            'description'       => $row['description'],
            'consult_type'      => $row['consult_type'],
            'online_fee'        => intval($row['online_fee']),
            'offline_fee'       => intval($row['offline_fee'])
        ];
    }, $result);
}
/*hamburger*/

}

?>