<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ws_model extends CI_Model{

/*default functions*/
public function common_fetch($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_select($table, $where = [], $select = '*', $integerFields = []) {
    $this->db->select($select);
    $this->db->from($table);
    
    if (!empty($where)) {
        $this->db->where($where);
    }
    $this->db->order_by('id','desc');
    $query = $this->db->get();
    
    if ($query->num_rows() > 0) {
        $result = $query->result_array();
        
        // Type-cast requested fields to integer
        if (!empty($integerFields)) {
            foreach ($result as &$row) {
                foreach ($integerFields as $field) {
                    if (isset($row[$field])) {
                        $row[$field] = (int) $row[$field];
                    }
                }
            }
            unset($row);
        }
        
        return $result;
    } else {
        return [];
    }
}
public function common_fetch_asc($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','asc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_insert($table,$data){	
	$this->db->insert($table,$data);
	$id = $this->db->insert_id();
	return $id;
}
public function common_update($table,$data,$where){
	$this->db->where($where);
	$this->db->update($table,$data);
}
public function common_delete($table,$where){
	$this->db->where($where);
	$this->db->delete($table);
}
public function common_fetch_rows($table,$where){
	$this->db->where($where);	
	$query = $this->db->get($table);
	return $query->num_rows();
}
// In your Ws_model.php
public function is_exists($table, $where = []) {
    $this->db->from($table);
    if (!empty($where)) {
        $this->db->where($where);
    }
    $query = $this->db->limit(1)->get();
    return $query->num_rows() > 0;
}

/*default functions*/

/*home_page*/
public function online_doctor_bookings_history_active($user_id, $limit, $offset) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile,b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, s.name AS specialization, d.name AS doctor_name, fm.email, fm.gender, fm.dob, fm.image, bg.name as blood_group,GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification');

    $this->db->from('online_doctor_bookings b');
    $this->db->join('online_doctor_specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('online_doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    // Filter active bookings for the doctor
    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'booked');

    // Avoid duplicates in case of joins
    $this->db->group_by('b.id');

    // Custom ordering: today's bookings first, then older dates
    $today = date('Y-m-d');
    $this->db->order_by("CASE 
        WHEN b.date = '{$today}' THEN 0 
        ELSE 1 
    END", "ASC"); // Today comes first
    $this->db->order_by('b.date', 'DESC'); // Then remaining in descending order

    // Pagination
    $this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    // Format and return result
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'specialization'    => $row['specialization'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group'],
            'qualification'     => $row['qualification']
        ];
    }, $result);
}
public function online_doctor_bookings_history_active_rows($user_id) {
    $this->db->from('online_doctor_bookings b');
    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'booked');
    return $this->db->count_all_results();
}
// public function get_online_doctor_slots($user_id, $booked_date, $booked_time) {
//     $today = date('Y-m-d');
//     $slots_by_date = [];

//     // Fetch all available slots from the online_doctor_slots table
//     $this->db->select('id, time, session, booking_status, date');
//     $this->db->from('online_doctor_slots');
//     $this->db->where('doctor_id', $user_id);
//     $this->db->where('status', 1);
//     $this->db->where('delete_status', 1);
//     $this->db->where('date >=', $today); // Only fetch slots from today onward
//     $this->db->order_by('date', 'ASC');
//     $this->db->order_by('time', 'ASC');
    
//     $query = $this->db->get();
//     $results = $query->result_array();

//     foreach ($results as $row) {
//         $date = $row['date'];
//         $session = $row['session'];

//         // Skip slots for past dates (before today) or slots before the booked time for today
//         if ($date === $booked_date) {
//             if ($row['time'] < $booked_time) {
//                 continue; // Skip slots before the booked time on the booking date
//             }
//         }
        
//         // Skip slots for dates before today
//         if ($date < $today) {
//             continue; // Skip past dates
//         }

//         // Format date and organize slots by session
//         $row['id'] = (int) $row['id'];
//         $row['format_date'] = date('D d M', strtotime($date));

//         if (!isset($slots_by_date[$date])) {
//             $slots_by_date[$date] = [
//                 'morning' => [],
//                 'afternoon' => [],
//                 'evening' => []
//             ];
//         }

//         $slots_by_date[$date][$session][] = $row;
//     }

//     return ['slots' => $slots_by_date];
// }
public function get_online_doctor_slots($user_id, $date) {
    $today = date('Y-m-d');
    $current_time = date('H:i'); // current time in 24-hour format

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('online_doctor_slots');
    $this->db->where('doctor_id', $user_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // If today, filter out past time slots (we do this in PHP after query)
    $this->db->order_by('id', 'ASC'); // Use ID or leave unordered (will sort in PHP)

    $query = $this->db->get();
    $results = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];

    foreach ($results as $row) {
        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        // Convert time (12-hour) to 24-hour for sorting & filtering
        $slot_time_24hr = date('H:i', strtotime($row['time']));

        // Filter out past slots for today's date
        if ($date == $today && $slot_time_24hr < $current_time) {
            continue;
        }

        // Assign session
        if ($slot_time_24hr >= '05:00' && $slot_time_24hr < '12:00') {
            $slots['morning'][] = $row;
        } elseif ($slot_time_24hr >= '12:00' && $slot_time_24hr < '16:00') {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    // Sort each session manually by slot time
    foreach ($slots as &$session) {
        usort($session, function ($a, $b) {
            return strtotime($a['time']) - strtotime($b['time']);
        });
    }

    return ['slots' => $slots];
}
/*home_page*/

/*hamburger*/
public function get_doctor_booked_slots($doctor_id,$date) {
    $this->db->select('id as slot_id, time, date, booking_status');
    $this->db->from('online_doctor_slots');
    $this->db->where('doctor_id', $doctor_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1); // Ensure only active slots are fetched
    $this->db->where('delete_status', 1); // Ensure only non-deleted slots are fetched

    $results = $this->db->get()->result_array();

    // Normalize time format
    foreach ($results as &$row) {
        $row['time'] = date('h:i A', strtotime($row['time']));
    }

    return $results;
}
public function online_doctor_bookings_history_completed($user_id, $limit, $offset) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, s.name AS specialization, d.name AS doctor_name, fm.email, fm.gender, fm.dob, fm.image, bg.name as blood_group');

    $this->db->from('online_doctor_bookings b');
    $this->db->join('online_doctor_specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('online_doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');
    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    $this->db->group_by('b.id');
    $this->db->order_by('b.id', 'DESC');
    $this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    $final_result = [];

    foreach ($result as $row) {
        $booking_id = $row['booking_id'];

        // Fetch medicines
        $medicines = $this->db->get_where('online_doctor_booking_medicines', ['booking_id' => $booking_id])->result_array();

        // Fetch notes
        $notes = $this->db->get_where('online_doctor_booking_notes', ['booking_id' => $booking_id])->result_array();

        // Fetch tests
        $tests = $this->db->get_where('online_doctor_booking_tests', ['booking_id' => $booking_id])->result_array();

        $final_result[] = [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'specialization'    => $row['specialization'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group'],
            'medicines'         => !empty($medicines) ? $medicines : [],
            'notes'             => !empty($notes) ? $notes : [],
            'tests'             => !empty($tests) ? $tests : [],
        ];
    }

    return $final_result;
}
public function online_doctor_bookings_history_completed_rows($user_id) {
    $this->db->from('online_doctor_bookings b');
    $this->db->where('b.doctor_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    return $this->db->count_all_results();
}
public function online_doctor_single_booking_history_completed($booking_id) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, b.booking_status,s.name AS specialization, d.name AS doctor_name,GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification, fm.email, fm.gender, fm.dob, fm.image, bg.name as blood_group');

    $this->db->from('online_doctor_bookings b');
    $this->db->join('online_doctor_specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('online_doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');
    $this->db->where('b.booking_id', $booking_id);
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    //$this->db->where('b.booking_status', 'completed');
    $this->db->group_by('b.id');
    $this->db->order_by('b.id', 'DESC');
    //$this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    $final_result = [];

    foreach ($result as $row) {
        $booking_id = $row['booking_id'];

        // Fetch medicines
        $medicines = $this->db
        ->select('medicine, medicine_time')
        ->get_where('online_doctor_booking_medicines', ['booking_id' => $booking_id])
        ->result_array();

        
        // Fetch tests
        $tests = $this->db
        ->select('test, test_instruction')
        ->get_where('online_doctor_booking_tests', ['booking_id' => $booking_id])
        ->result_array();
        
        // Fetch notes
        
        $notes = $this->db
            ->select('notes')
            ->get_where('online_doctor_booking_notes', ['booking_id' => $booking_id])
            ->result_array();
        
        // Extract just the 'notes' values into a simple array
        $note_values = array_column($notes, 'notes');
        
        // Assign directly to your output array
        $data = $note_values;

        $final_result[] = [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'specialization'    => $row['specialization'],
            'name'              => $row['doctor_name'],
            'qualification'     => $row['qualification'],
            'image'             => $row['image'],
            'booking_status'    => $row['booking_status'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group'],
            'medicines'         => !empty($medicines) ? $medicines : [],
            'tests'             => !empty($tests) ? $tests : [],
            'notes'             => !empty($notes) ? $data : []
        ];
    }

    return $final_result;
}
public function online_doctor_profile($user_id){
    $this->db->select('online_doctors.id,online_doctors.unique_id,online_doctors.speciality_id,online_doctors.name,online_doctors.mobile,online_doctors.image,online_doctors.open_time,online_doctors.close_time,online_doctors.qualification,online_doctors.exp,online_doctors.description,online_doctors.fee,online_doctor_specialities.name as specialization,GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification')->from('online_doctors');
    $this->db->where('online_doctors.id',$user_id);
    $this->db->join('online_doctor_specialities','online_doctor_specialities.id=online_doctors.speciality_id','left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, online_doctors.qualification)', 'left');
    $this->db->group_by('online_doctors.id');
    $query = $this->db->get();
    $result = $query->result_array();
    // Map data
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'unique_id'         => $row['unique_id'],
            'speciality_id'     => intval($row['speciality_id']),
            'name'              => $row['name'],
            'mobile'            => intval($row['mobile']),
            'image'             => $row['image'],
            'open_time'         => $row['open_time'],
            'close_time'        => $row['close_time'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => intval($row['exp']),
            'description'       => $row['description'],
            'fee'               => intval($row['fee'])
        ];
    }, $result);
}
/*hamburger*/

}

?>