<div class="container-xxl flex-grow-1 container-p-y">
              <h4 class="py-3 mb-4"><span class="text-muted fw-light">Add Doctor</h4>
              
  <div class="row"><div class="col-md-6">
      <div class="card mb-4">
          <form method="post" action="#" id="inputform" enctype="multipart/form-data">
        <div class="card-body">
            
            <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Speciality *</label>
            <select class="form-select" name="speciality_id" required placeholder="Speciality">
                <option value="">Select Speciality</option>
                <?php if(!empty($specialities)){ 
                foreach($specialities as $row){?>
                <option value="<?=$row['speciality_id']?>"><?=$row['name']?></option>
                <?php } } ?>
            </select>
          </div>
            
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Name *</label>
            <input
              type="text"
              class="form-control"
              id="exampleFormControlInput1"
              placeholder="Name" name="name" required/>
          </div>
          
          <div class="mb-3">
            <label>Mobile *</label>
            <input type="tel" maxlength="10" pattern="[0-9]{10}" oninput="this.value = this.value.replace(/[^0-9]/g, '')" placeholder="Mobile" name="mobile" required class="form-control">
        </div>
         
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Image *</label>
            <input
              type="file"
              class="form-control"
              id="exampleFormControlInput1"
               name="image" placeholder="Image" required/>
          </div>
          <p style="color:red">please upload only jpg,jpeg and png format files</p>
          
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Qualification *</label>
            <select class="form-select" name="qualification[]" required placeholder="Qualification" multiple>
                <option value="">Select Qualification</option>
                <?php if(!empty($medical_degrees)){ 
                foreach($medical_degrees as $medical_degree_row){?>
                <option value="<?=$medical_degree_row['id']?>"><?=$medical_degree_row['name']?></option>
                <?php } } ?>
            </select>
          </div>
          
          
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Exp *</label>
            <input
              type="number"
              class="form-control"
              id="exampleFormControlInput1"
              placeholder="Exp" name="exp" required/>
          </div>
          
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Description *</label>
            <textarea class="form-control"
              id="exampleFormControlInput1"
              placeholder="Description" name="description" required></textarea>
          </div>
          
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Online Fee *</label>
            <input
              type="number"
              class="form-control"
              id="exampleFormControlInput1"
              placeholder="Online Fee" name="online_fee" required/>
          </div>
          
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Offline Fee *</label>
            <input
              type="number"
              class="form-control"
              id="exampleFormControlInput1"
              placeholder="Offline Fee" name="offline_fee" required/>
          </div>
          
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Consult Type *</label>
            <select class="form-select" name="consult_type" required placeholder="Consult Type">
                <option value="">Select Consult Type</option>
                <option value="online">Online</option>
                <option value="offline">Offline</option>
            </select>
          </div>
          
          <div class="mb-3">
            <label for="exampleFormControlInput1" class="form-label">Unique Id *</label>
            <input
              type="text"
              class="form-control"
              id="exampleFormControlInput1"
              placeholder="Unique Id" name="unique_id" required/>
          </div>
          
        </div>
      </div>
       <button type="button" name="sub" value="sub" class="btn btn-success" id="saveBtn">Submit</button>
      </form>
      <a href="<?=base_url('hospital_admin/register/doctors')?>"><button type="button" class="btn btn-danger">Cancel</button></a>
    </div></div>
</div>



<script>
$(document).ready(function () {
    $('#saveBtn').on('click', function () {
        let isValid = true;

        // Validate required fields
        $('#inputform [required]').each(function () {
            let value = $(this).val(); // Get the value
            if (Array.isArray(value)) {
                value = value.join(''); // Convert array to string
            }
            value = value ? value.toString().trim() : ''; // Convert value to string and trim

            if (value === '') {
                isValid = false;
                $(this).addClass('is-invalid'); // Add error styling
                showToast('Error', `${$(this).attr('placeholder')} is required`, 'error');
            } else {
                // Mobile Validation
                const mobileField = $('input[name="mobile"]');
                const mobile = mobileField.val().trim();
                const mobilePattern = /^[0-9]{10}$/; // RegEx for a 10-digit mobile number
                if (!mobilePattern.test(mobile)) {
                    isValid = false;
                    mobileField.addClass('is-invalid');
                    showToast('Error', 'Please enter a valid 10-digit mobile number', 'error');
                } else {
                    mobileField.removeClass('is-invalid').addClass('is-valid');
                }
                $(this).removeClass('is-invalid'); // Remove error styling
                $(this).addClass('is-valid'); // Mark as valid
            }
        });
        

        if (isValid) {
            // If all fields are valid, submit the form
            const form = $('#inputform')[0];
            const formData = new FormData(form);

            $.ajax({
                url: '<?= base_url("hospital_admin/register/insert_doctor"); ?>', // Your endpoint
                type: 'POST',
                data: formData,
                contentType: false,
                processData: false,
                success: function (response) {
                    const res = JSON.parse(response);
                    if (res.success) {
                        showToast('Success', res.message, 'success');
                        $('#inputform')[0].reset(); // Reset the form
                        $('.form-control').removeClass('is-valid'); // Clear valid states
                    } else {
                        showToast('Error', res.message, 'error');
                    }
                },
                error: function () {
                    showToast('Error', 'An unexpected error occurred.', 'error');
                },
            });
        } else {
            // Scroll to the first invalid field
            $('html, body').animate({
                scrollTop: $('.is-invalid:first').offset().top - 100,
            }, 500);
        }
    });

    // Remove validation feedback on input
    $('#inputform .form-control').on('input change', function () {
        if ($(this).val().trim() !== '') {
            $(this).removeClass('is-invalid').addClass('is-valid');
        } else {
            $(this).removeClass('is-valid').addClass('is-invalid');
        }
    });
});

</script>

<!-- Toastr CSS -->
<link href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.css" rel="stylesheet">
<!-- Toastr JS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>


<script>
// Show toast using jQuery
function showToast(title, message, type) {
    toastr.options = {
        closeButton: true,
        progressBar: true,
        positionClass: "toast-top-right",
        timeOut: "3000",
    };

    if (type === 'success') {
        toastr.success(message, title);
    } else if (type === 'error') {
        toastr.error(message, title);
    } else if (type === 'info') {
        toastr.info(message, title);
    } else if (type === 'warning') {
        toastr.warning(message, title);
    }
}


</script>
            