<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Ws_model extends CI_Model{

/*default functions*/
public function common_fetch($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','desc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_fetch_select($table, $where = [], $select = '*', $integerFields = []) {
    $this->db->select($select);
    $this->db->from($table);
    
    if (!empty($where)) {
        $this->db->where($where);
    }
    $this->db->order_by('id','desc');
    $query = $this->db->get();
    
    if ($query->num_rows() > 0) {
        $result = $query->result_array();
        
        // Type-cast requested fields to integer
        if (!empty($integerFields)) {
            foreach ($result as &$row) {
                foreach ($integerFields as $field) {
                    if (isset($row[$field])) {
                        $row[$field] = (int) $row[$field];
                    }
                }
            }
            unset($row);
        }
        
        return $result;
    } else {
        return [];
    }
}
public function common_fetch_asc($table,$where){
	$this->db->where($where);
	$this->db->order_by('id','asc');
	$query = $this->db->get($table);
	return $query->result_array();
}
public function common_insert($table,$data){	
	$this->db->insert($table,$data);
	$id = $this->db->insert_id();
	return $id;
}
public function common_update($table,$data,$where){
	$this->db->where($where);
	$this->db->update($table,$data);
}
public function common_delete($table,$where){
	$this->db->where($where);
	$this->db->delete($table);
}
public function common_fetch_rows($table,$where){
	$this->db->where($where);	
	$query = $this->db->get($table);
	return $query->num_rows();
}
// In your Ws_model.php
public function is_exists($table, $where = []) {
    $this->db->from($table);
    if (!empty($where)) {
        $this->db->where($where);
    }
    $query = $this->db->limit(1)->get();
    return $query->num_rows() > 0;
}

/*default functions*/

/*home page*/
public function get_vendors($data){
    $this->db->select("COALESCE(( 6371 * acos( cos( radians({$data['lat']}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$data['lon']}) ) + sin( radians({$data['lat']}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance,sp.*", False);
    $this->db->from('storage_partners sp'); 
	//$this->db->where('vendor_id',$data['vendor_id']);
    $this->db->where('status',1);
	$this->db->where('to_date>',date('Y-m-d'));
    $this->db->order_by('distance','asc');
    $query = $this->db->get();
    return $query->result_array();
}
/*home page*/

/*pharmacy*/
public function get_pharmacy_main_data_first($lat, $lon, $radius, $limit, $offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        pharmacies.id,pharmacies.name,pharmacies.open_time,pharmacies.close_time,pharmacies.logo,pharmacies.location,pharmacies.lat,pharmacies.lon,pharmacies.home_delivery", false);
    $this->db->from('pharmacies');
    
    // Filters
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);
    $this->db->where('pharmacies.availability', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('pharmacies.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'            => intval($row['id']),
            'name'          => $row['name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'lat'           => $row['lat'],
            'lon'           => $row['lon'],
            'home_delivery' => $row['home_delivery'],
        ];
    }, $result);
}
public function get_pharmacy_data_first_rows($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        pharmacies.id,pharmacies.name,pharmacies.open_time,pharmacies.close_time,pharmacies.logo,pharmacies.location,pharmacies.lat,pharmacies.lon,pharmacies.home_delivery", false);
    $this->db->from('pharmacies');
    
    // Filters
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);
    $this->db->where('pharmacies.availability', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('pharmacies.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    
    return $result;
}
public function get_search_pharmacy_main_data_first($lat, $lon, $search, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        pharmacies.id, pharmacies.name, pharmacies.open_time, pharmacies.close_time,
        pharmacies.logo, pharmacies.location, pharmacies.lat, pharmacies.lon, pharmacies.home_delivery", false);

    $this->db->from('pharmacies');

    // Status filters
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);
    $this->db->where('pharmacies.availability', 1);

    // Multilingual name search (name_en, name_hi, name_te)
    $this->db->like('pharmacies.name', $search);

    // Distance filter
    $this->db->having('distance <=', $radius);

    // Grouping & ordering
    $this->db->group_by('pharmacies.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'            => intval($row['id']),
            'name'          => $row['name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'lat'           => $row['lat'],
            'lon'           => $row['lon'],
            'home_delivery' => $row['home_delivery'],
        ];
    }, $result);
}
public function get_pharmacy_main_data($main_data_id) {
    $this->db->select("
        pharmacies.*, 
        GROUP_CONCAT(DISTINCT img.image) AS images
    ", false); 
    
    $this->db->from('pharmacies');

    // Join with pharmacy_images (optional images)
    $this->db->join('pharmacy_images img', 'img.main_data_id = pharmacies.id AND img.status = 1 AND img.delete_status = 1', 'left');

    // Filters
    $this->db->where('pharmacies.id', $main_data_id);
    $this->db->where('pharmacies.status', 1);
    $this->db->where('pharmacies.delete_status', 1);
    $this->db->where('pharmacies.availability', 1);

    // Group by for images aggregation
    $this->db->group_by('pharmacies.id');

    $query  = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        // Load categories only if 'pharmacy' is 'yes'
        $pharmacy_categories = [];
        $CI =& get_instance();
        $CI->db->select('id, name, image');
        $CI->db->from('pharmacy_categories');
        $CI->db->where('status', 1);
        $CI->db->where('delete_status', 1);
        $CI->db->order_by('id', 'desc');
        $category_results = $CI->db->get()->result_array();

        $pharmacy_categories = array_map(function ($item) {
            return [
                'id'    => intval($item['id']),
                'name'  => $item['name'],
                'image' => $item['image']
            ];
        }, $category_results);

        return [
            'id'                => intval($row['id']),
            'name'              => $row['name'],
            'mobile'            => intval($row['mobile']),
            'logo'              => $row['logo'],
            'open_time'         => $row['open_time'],
            'close_time'        => $row['close_time'],
            'location'          => $row['location'],
            'description'       => $row['description'],
            'lat'               => $row['lat'],
            'lon'               => $row['lon'],
            'home_delivery'     => $row['home_delivery'],
            'images'            => (!empty($row['images']) && is_string($row['images']))
                ? array_map(function ($image) {
                    return ['url' => trim($image)];
                }, array_filter(explode(',', $row['images'])))
                : [],
            'pharmacy_categories' => $pharmacy_categories
        ];
    }, $result);
}
public function get_pharmacy_products($pharmacy_id, $cat_id, $user_id, $limit, $offset) {
    $this->db->select('
        pp.id,
        pp.main_data_id,
        pp.cat_id,
        pp.name,
        pp.image,
        pp.price,
        pp.discount_price,
        IFNULL(ppc.id, 0) AS cart_id,
        IFNULL(ppc.cart_quantity, 0) AS cart_quantity
    ');
    $this->db->from('pharmacy_products pp');
    $this->db->where([
        'pp.main_data_id' => $pharmacy_id,
        'pp.cat_id'       => $cat_id,
        'pp.status'       => 1,
        'pp.delete_status'=> 1
    ]);
    $this->db->join('pharmacy_products_cart ppc', 'pp.id = ppc.product_id AND ppc.user_id = '.$this->db->escape($user_id), 'left');
    $this->db->order_by('pp.id', 'desc');
    $this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        return [
            'id'             => intval($row['id']),
            'main_data_id'   => intval($row['main_data_id']),
            'cat_id'         => intval($row['cat_id']),
            'name'           => $row['name'],
            'image'          => $row['image'],
            'price'          => intval($row['price']),
            'discount_price' => intval($row['discount_price']),
            'cart_id'        => intval($row['cart_id']),
            'cart_quantity'  => intval($row['cart_quantity'])
        ];
    }, $result);
}
public function get_pharmacy_products_rows($pharmacy_id,$cat_id){
    $this->db->where(['main_data_id' => $pharmacy_id,'cat_id' => $cat_id,'status' => 1,'delete_status' => 1]);
    $this->db->order_by('id','desc');
    $query = $this->db->get('pharmacy_products');
    $result = $query->num_rows();
    return $result;
}
public function pharmacy_product_cart($user_id){
    $this->db->select('pharmacy_products_cart.id,pharmacy_products_cart.user_id,pharmacy_products_cart.main_data_id,pharmacy_products_cart.cat_id,pharmacy_products_cart.product_id,pharmacy_products_cart.price,pharmacy_products_cart.cart_quantity,pharmacy_products.name,pharmacy_products.image,pharmacy_products_cart.price,pharmacy_products_cart.original_price')->from('pharmacy_products_cart');
    $this->db->where('user_id',$user_id);
    $this->db->join('pharmacy_products','pharmacy_products.id=pharmacy_products_cart.product_id','left');
    $this->db->order_by('pharmacy_products_cart.id', 'desc');
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'user_id'           => intval($row['user_id']),
            'pharmacy_id'       => intval($row['main_data_id']),
            'cat_id'            => intval($row['cat_id']),
            'product_id'        => intval($row['product_id']),
            'price'             => intval($row['price']),
            'original_price'    => intval($row['original_price']),
            'cart_quantity'     => intval($row['cart_quantity']),
            'name'              => $row['name'],
            'image'             => $row['image']
        ];
    }, $result);
}
public function get_product_orders($user_id) {
    $this->db->select('pb.id, pb.booking_id, pb.created_on, pb.order_type, pb.booking_type,pb.booking_status,pb.accept_status, pbi.id AS product_id, pbi.name AS product_name, pbi.image, pbi.price, pbi.original_price, pbi.image,p.name as hospital_name');
    $this->db->from('pharmacy_product_bookings pb');
    $this->db->join('pharmacy_booked_products pbi', 'pbi.booking_id = pb.booking_id', 'left');
    $this->db->join('pharmacies p', 'p.id = pb.main_data_id', 'left');
    //$this->db->join('pharmacy_products p', 'p.id = pbi.product_id', 'left');
    $this->db->where('pb.user_id', $user_id);
    $this->db->where('pb.booking_status', 'booked');

    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('pb.accept_status', 'accepted');
    $this->db->or_where('pb.accept_status', '');
    $this->db->group_end();

    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'           => intval($row->id),
                'booking_id'   => $row->booking_id,
                'hospital_name'=> $row->hospital_name,
                'order_type'   => $row->order_type,
                'booking_type'      => $row->booking_type,
                'booking_status'    => $row->booking_status,
                'accept_status'=> $row->accept_status,
                'created_on'   => $row->created_on,
                'products'     => []
            ];
        }
        $result[$id]['products'][] = [
            'product_name'      => $row->product_name,
            'image'             => $row->image,
            'price'             => $row->price,
            'original_price'    => $row->original_price
        ];
    }

    return array_values($result);
}
public function get_prescription_orders($user_id){
    $this->db->select('pmd.id, pmd.booking_id, pmd.order_type, pmd.created_on,pmd.booking_type,pmd.booking_status,pmd.image,pmd.accept_status,p.name as hospital_name');
    $this->db->from('pharmacy_medicine_orders pmd');
    $this->db->where(['pmd.user_id' => $user_id,'pmd.booking_status' => 'booked']);
    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('pmd.accept_status', 'accepted');
    $this->db->or_where('pmd.accept_status', '');
    $this->db->group_end();
    $this->db->join('pharmacies p', 'p.id = pmd.main_data_id', 'left');
    $this->db->order_by('created_on', 'DESC');
    $query = $this->db->get();
    $orders = $query->result_array();

    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'hospital_name'     => $row['hospital_name'],
            'order_type'        => $row['order_type'],
            'created_on'        => $row['created_on'],
            'booking_type'      => $row['booking_type'],
            'booking_status'    => $row['booking_status'],
            'image'             => $row['image'],
            'accept_status'     => $row['accept_status'],
            'products'          => []
        ];
    }, $orders);
}
public function pharmacy_combined_orders($user_id, $limit, $offset, $page) {
    $product_orders = $this->get_product_orders($user_id);
    $prescription_orders = $this->get_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);
    
    if (!empty($combined)) {
        usort($combined, function($a, $b) {
            return strtotime($b->created_on ?? $b['created_on']) - strtotime($a->created_on ?? $a['created_on']);
        });

        // Pagination manually
        $paged_orders = array_slice($combined, $offset, $limit);
        $total_pages = ceil(count($combined) / $limit);
        $pages = [];

        for ($t = 1; $t <= $total_pages; $t++) {
            $pages[] = ['page' => $t];
        }

        return [
            'orders' => $paged_orders,
            'pagination' => [
                'total_pages'  => $pages,
                'current_page' => $page,
                'limit'        => $limit
            ]
        ];
    } else {
        return [
            'orders' => [],
            'pagination' => [
                'total_pages'  => [],
                'current_page' => $page,
                'limit'        => $limit
            ]
        ];
    }
}
public function get_completed_product_orders($user_id) {
    $this->db->select('pb.id, pb.booking_id, pb.created_on, pb.order_type, pb.booking_type,pb.booking_status,pb.accept_status, pbi.id AS product_id, pbi.name AS product_name, pbi.image, pbi.price, pbi.original_price,p.name as hospital_name');
    $this->db->from('pharmacy_product_bookings pb');
    $this->db->join('pharmacy_booked_products pbi', 'pbi.booking_id = pb.booking_id', 'left');
    $this->db->join('pharmacies p', 'p.id = pb.main_data_id', 'left');
    //$this->db->join('pharmacy_products p', 'p.id = pbi.product_id', 'left');
    $this->db->where('pb.user_id', $user_id);
    $this->db->where('pb.booking_status', 'completed');

    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'           => intval($row->id),
                'booking_id'   => $row->booking_id,
                'hospital_name'=> $row->hospital_name,
                'order_type'   => $row->order_type,
                'booking_type' => $row->booking_type,
                'booking_status' => $row->booking_status,
                'accept_status'=> $row->accept_status,
                'created_on'   => $row->created_on,
                'products'     => []
            ];
        }
        $result[$id]['products'][] = [
            'product_name'      => $row->product_name,
            'image'             => $row->image,
            'price'             => $row->price,
            'original_price'    => $row->original_price
        ];
    }

    return array_values($result);
}
public function get_completed_prescription_orders($user_id){
    $this->db->select('pmd.id, pmd.booking_id, pmd.order_type, pmd.created_on,pmd.booking_type,pmd.booking_status,pmd.image,pmd.accept_status,p.name as hospital_name');
    $this->db->from('pharmacy_medicine_orders pmd');
    $this->db->where(['pmd.user_id' => $user_id,'pmd.booking_status' => 'completed']);
    $this->db->join('pharmacies p', 'p.id = pmd.main_data_id', 'left');
    $this->db->order_by('pmd.created_on', 'DESC');

    $query = $this->db->get();
    $orders = $query->result_array();

    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'hospital_name'     => $row['hospital_name'],
            'order_type'        => $row['order_type'],
            'created_on'        => $row['created_on'],
            'booking_type'      => $row['booking_type'],
            'booking_status'    => $row['booking_status'],
            'image'             => $row['image'],
            'accept_status'     => $row['accept_status'],
            'products'          => []
        ];
    }, $orders);
}
public function pharmacy_completed_combined_orders($user_id, $limit, $offset, $page) {
    $product_orders      = $this->get_completed_product_orders($user_id);
    $prescription_orders = $this->get_completed_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    if (!empty($combined)) {
        usort($combined, function($a, $b) {
            return strtotime($b->created_on ?? $b['created_on']) - strtotime($a->created_on ?? $a['created_on']);
        });

        // Total pages calculation
        $total_records = count($combined);
        $total_pages   = ceil($total_records / $limit);

        // Paginate
        $paged_orders = array_slice($combined, $offset, $limit);

        // Build pages array
        $pages = [];
        for ($i = 1; $i <= $total_pages; $i++) {
            $pages[] = ['page' => $i];
        }

        return [
            'orders' => $paged_orders,
            'pagination' => [
                'total_pages'  => $pages,
                'current_page' => floor($offset / $limit) + 1,
                'limit'        => $limit
            ]
        ];
    } else {
        return [
            'orders' => [],
            'pagination' => [
                'total_pages'  => [],
                'current_page' => $page,
                'limit'        => $limit
            ]
        ];
    }
}
public function get_single_product_orders($booking_id){
    $this->db->select('pb.id,pb.booking_id, pb.created_on, pb.order_type, pb.user_id, pb.main_data_id, pb.cat_id, pb.address_id, pb.mobile, pb.name, pb.fee, pb.consultation_fee, pb.coupon_id,pb.coupon_name,pb.coupon_percentage,pb.coupon_discount,pb.payment_type,pb.booking_status,pb.order_type,pb.booking_type,pb.accept_status, pbi.id AS product_id, pbi.name AS product_name, pbi.image,pbi.price,pbi.original_price,pbi.cart_quantity,u.image as user_image,p.name as hospital_name');
    $this->db->from('pharmacy_product_bookings pb');
    $this->db->join('pharmacy_booked_products pbi', 'pbi.booking_id = pb.booking_id', 'left');
    $this->db->join('pharmacies p', 'p.id = pb.main_data_id', 'left');
    //$this->db->join('pharmacy_products p', 'p.id = pbi.product_id', 'left');
    $this->db->join('users u', 'u.id = pb.user_id', 'left');
    $this->db->where('pb.booking_id', $booking_id);
    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    // Group by booking ID to avoid duplication
    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'                => intval($row->id),
                'booking_id'        => $row->booking_id,
                'hospital_name'     => $row->hospital_name,
                'order_type'        => $row->order_type,
                'user_id'           => intval($row->user_id),
                'main_data_id'      => intval($row->main_data_id),
                'cat_id'            => intval($row->cat_id),
                'address_id'        => intval($row->address_id),
                'name'              => $row->name,
                'mobile'            => intval($row->mobile),
                'user_image'        => $row->user_image,
                'fee'               => intval($row->fee),
                'consultation_fee'  => intval($row->consultation_fee),
                'coupon_id'         => intval($row->coupon_id),
                'coupon_percentage' => intval($row->coupon_percentage),
                'coupon_discount'   => intval($row->coupon_discount),
                'payment_type'      => $row->payment_type,
                'order_type'        => $row->order_type,
                'booking_type'      => $row->booking_type,
                'booking_status'    => $row->booking_status,
                'accept_status'     => $row->accept_status,
                'created_on'        => $row->created_on,
                'products'          => []
            ];
        }
        $result[$id]['products'][] = [
            'hospital_name' => $row->hospital_name,
            'product_name' => $row->product_name,
            'image' => $row->image,
            'price' => intval($row->price),
            'original_price' => intval($row->original_price),
            'cart_quantity' => intval($row->cart_quantity),
        ];
    }

    return array_values($result);
}
public function get_single_medicine_orders($booking_id){
    $this->db->select('pb.id,pb.booking_id, pb.created_on, pb.order_type, pb.user_id, pb.main_data_id, pb.address_id, pb.mobile, pb.name,pb.booking_status,pb.order_type,pb.booking_type, pb.accept_status,pb.image,u.image as user_image,p.name as hospital_name');
    $this->db->from('pharmacy_medicine_orders pb');
    $this->db->join('users u', 'u.id = pb.user_id', 'left');
    $this->db->where('pb.booking_id', $booking_id);
    $this->db->join('pharmacies p', 'p.id = pb.main_data_id', 'left');
    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    // Group by booking ID to avoid duplication
    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'                => intval($row->id),
                'booking_id'        => $row->booking_id,
                'hospital_name'     => $row->hospital_name,
                'image'             => $row->image,
                'order_type'        => $row->order_type,
                'user_id'           => intval($row->user_id),
                'main_data_id'      => intval($row->main_data_id),
                'address_id'        => intval($row->address_id),
                'name'              => $row->name,
                'mobile'            => intval($row->mobile),
                'user_image'        => $row->user_image,
                'booking_type'      => $row->booking_type,
                'booking_status'    => $row->booking_status,
                'accept_status'     => $row->accept_status,
                'created_on'        => $row->created_on
            ];
        }
    }

    return array_values($result);
}
/*pharmacy*/

/*hospital_pharmacy_module*/
public function get_hospital_pharmacy_products($main_data_id, $cat_id, $user_id, $limit, $offset) {
    $this->db->select('
        pp.id,
        pp.main_data_id,
        pp.cat_id,
        pp.name,
        pp.image,
        pp.price,
        pp.discount_price,
        IFNULL(ppc.id, 0) AS cart_id,
        IFNULL(ppc.cart_quantity, 0) AS cart_quantity
    ');
    $this->db->from('hospital_pharmacy_products pp');
    $this->db->where([
        'pp.main_data_id' => $main_data_id,
        'pp.cat_id'       => $cat_id,
        'pp.status'       => 1,
        'pp.delete_status'=> 1
    ]);
    $this->db->join('hospital_pharmacy_products_cart ppc', 'pp.id = ppc.product_id AND ppc.user_id = '.$this->db->escape($user_id), 'left');
    $this->db->order_by('pp.id', 'desc');
    $this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        return [
            'id'             => intval($row['id']),
            'main_data_id'   => intval($row['main_data_id']),
            'cat_id'         => intval($row['cat_id']),
            'name'           => $row['name'],
            'image'          => $row['image'],
            'price'          => intval($row['price']),
            'discount_price' => intval($row['discount_price']),
            'cart_id'        => intval($row['cart_id']),
            'cart_quantity'  => intval($row['cart_quantity'])
        ];
    }, $result);
}
public function get_hospital_pharmacy_products_rows($main_data_id,$cat_id){
    $this->db->where(['main_data_id' => $main_data_id,'cat_id' => $cat_id,'status' => 1,'delete_status' => 1]);
    $this->db->order_by('id','desc');
    $query = $this->db->get('hospital_pharmacy_products');
    $result = $query->num_rows();
    return $result;
}
public function hospital_pharmacy_product_cart($user_id){
    $this->db->select('hospital_pharmacy_products_cart.id,hospital_pharmacy_products_cart.user_id,hospital_pharmacy_products_cart.main_data_id,hospital_pharmacy_products_cart.cat_id,hospital_pharmacy_products_cart.product_id,hospital_pharmacy_products_cart.price,hospital_pharmacy_products_cart.cart_quantity,hospital_pharmacy_products.name,hospital_pharmacy_products.image,hospital_pharmacy_products_cart.price,hospital_pharmacy_products_cart.original_price')->from('hospital_pharmacy_products_cart');
    $this->db->where('user_id',$user_id);
    $this->db->join('hospital_pharmacy_products','hospital_pharmacy_products.id=hospital_pharmacy_products_cart.product_id','left');
    $this->db->order_by('hospital_pharmacy_products_cart.id', 'desc');
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'user_id'           => intval($row['user_id']),
            'main_data_id'      => intval($row['main_data_id']),
            'cat_id'            => intval($row['cat_id']),
            'product_id'        => intval($row['product_id']),
            'price'             => intval($row['price']),
            'original_price'    => intval($row['original_price']),
            'cart_quantity'     => intval($row['cart_quantity']),
            'name'              => $row['name'],
            'image'             => $row['image']
        ];
    }, $result);
}
public function get_hospital_pharmacy_product_orders($user_id) {
    $this->db->select('pb.id, pb.booking_id, pb.created_on, pb.order_type, pb.booking_type,pb.booking_status,pb.accept_status, pbi.id AS product_id, pbi.name AS product_name, pbi.image, pbi.price, pbi.original_price,d.name as hospital_name');
    $this->db->from('hospital_pharmacy_product_bookings pb');
    $this->db->join('hospital_pharmacy_booked_products pbi', 'pbi.booking_id = pb.booking_id', 'left');
    $this->db->join('main_data d', 'd.id = pb.main_data_id', 'left');
    //$this->db->join('hospital_pharmacy_products p', 'p.id = pbi.product_id', 'left');
    $this->db->where('pb.user_id', $user_id);
    $this->db->where('pb.booking_status', 'booked');

    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('pb.accept_status', 'accepted');
    $this->db->or_where('pb.accept_status', '');
    $this->db->group_end();

    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'            => $row->id,
                'booking_id'    => $row->booking_id,
                'hospital_name' => $row->hospital_name,
                'order_type'    => $row->order_type,
                'booking_type'  => $row->booking_type,
                'booking_status' => $row->booking_status,
                'accept_status' => $row->accept_status,
                'created_on'    => $row->created_on,
                'products'      => []
            ];
        }
        $result[$id]['products'][] = [
            'product_name'      => $row->product_name,
            'image'             => $row->image,
            'price'             => $row->price,
            'original_price'    => $row->original_price
            
        ];
    }

    return array_values($result);
}
public function get_hospital_pharmacy_prescription_orders($user_id){
    $this->db->select('hpmd.id, hpmd.booking_id, hpmd.order_type, hpmd.created_on,hpmd.booking_type,hpmd.booking_status,hpmd.image,hpmd.accept_status,d.name as hospital_name');
    $this->db->from('hospital_pharmacy_medicine_orders hpmd');
    $this->db->where(['hpmd.user_id' => $user_id,'hpmd.booking_status' => 'booked']);
    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('hpmd.accept_status', 'accepted');
    $this->db->or_where('hpmd.accept_status', '');
    $this->db->group_end();
    $this->db->join('main_data d', 'd.id = hpmd.main_data_id', 'left');
    $this->db->order_by('created_on', 'DESC');

    $query = $this->db->get();
    $orders = $query->result();

    return $orders;
}
public function hospital_pharmacy_combined_orders($user_id, $limit, $offset){
    $product_orders = $this->get_hospital_pharmacy_product_orders($user_id);
    $prescription_orders = $this->get_hospital_pharmacy_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    usort($combined, function($a, $b) {
        return strtotime($b->created_on ?? $b['created_on']) - strtotime($a->created_on ?? $a['created_on']);
    });

    // Pagination manually
    $paged_orders = array_slice($combined, $offset, $limit);

    return [
        'orders' => $paged_orders,
        'total_orders' => count($combined),
        'limit' => $limit,
        'offset' => $offset
    ];
}
public function get_hospital_pharmacy_completed_product_orders($user_id) {
    $this->db->select('pb.id, pb.booking_id, pb.created_on, pb.order_type, pb.booking_type,pb.booking_status,pb.accept_status, pbi.id AS product_id, pbi.name AS product_name, pbi.image, pbi.price, pbi.original_price,d.name as hospital_name');
    $this->db->from('hospital_pharmacy_product_bookings pb');
    $this->db->join('hospital_pharmacy_booked_products pbi', 'pbi.booking_id = pb.booking_id', 'left');
    $this->db->join('main_data d', 'd.id = pb.main_data_id', 'left');
    //$this->db->join('hospital_pharmacy_products p', 'p.id = pbi.product_id', 'left');
    $this->db->where('pb.user_id', $user_id);
    $this->db->where('pb.booking_status', 'completed');

    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'           => $row->id,
                'booking_id'   => $row->booking_id,
                'hospital_name' => $row->hospital_name,
                'order_type'   => $row->order_type,
                'booking_type' => $row->booking_type,
                'booking_status' => $row->booking_status,
                'accept_status'=> $row->accept_status,
                'created_on'   => $row->created_on,
                'products'     => []
            ];
        }
        $result[$id]['products'][] = [
            'product_name'      => $row->product_name,
            'image'             => $row->image,
            'price'             => $row->price,
            'original_price'    => $row->original_price
        ];
    }

    return array_values($result);
}
public function get_hospital_pharmacy_completed_prescription_orders($user_id){
    $this->db->select('hpmd.id, hpmd.booking_id, hpmd.order_type, hpmd.created_on,hpmd.booking_type,hpmd.booking_status,hpmd.image,hpmd.accept_status,d.name as hospital_name');
    $this->db->from('hospital_pharmacy_medicine_orders hpmd');
    $this->db->where(['hpmd.user_id' => $user_id,'hpmd.booking_status' => 'completed']);
    $this->db->join('main_data d', 'd.id = hpmd.main_data_id', 'left');
    $this->db->order_by('created_on', 'DESC');
    $query = $this->db->get();
    $orders = $query->result();

    return $orders;
}
public function hospital_pharmacy_completed_combined_orders($user_id, $limit, $offset){
    $product_orders = $this->get_hospital_pharmacy_completed_product_orders($user_id);
    $prescription_orders = $this->get_hospital_pharmacy_completed_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    usort($combined, function($a, $b) {
        return strtotime($b->created_on ?? $b['created_on']) - strtotime($a->created_on ?? $a['created_on']);
    });

    // Pagination manually
    $paged_orders = array_slice($combined, $offset, $limit);

    return [
        'orders' => $paged_orders,
        'total_orders' => count($combined),
        'limit' => $limit,
        'offset' => $offset
    ];
}
public function get_hospital_pharmacy_single_product_orders($booking_id){
    $this->db->select('pb.id,pb.booking_id, pb.created_on, pb.order_type, pb.user_id, pb.main_data_id, pb.cat_id, pb.address_id, pb.mobile, pb.name, pb.fee, pb.consultation_fee, pb.coupon_id,pb.coupon_name,pb.coupon_percentage,pb.coupon_discount,pb.payment_type,pb.booking_status,pb.order_type,pb.booking_type,pb.accept_status, pbi.id AS product_id, pbi.name AS product_name, pbi.image,pbi.price,pbi.original_price,pbi.cart_quantity,u.image as user_image,md.name as hospital_name');
    $this->db->from('hospital_pharmacy_product_bookings pb');
    $this->db->join('hospital_pharmacy_booked_products pbi', 'pbi.booking_id = pb.booking_id', 'left');
    //$this->db->join('hospital_pharmacy_products p', 'p.id = pbi.product_id', 'left');
    $this->db->join('users u', 'u.id = pb.user_id', 'left');
    $this->db->join('main_data md', 'md.id = pb.main_data_id', 'left');
    $this->db->where('pb.booking_id', $booking_id);
    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    // Group by booking ID to avoid duplication
    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'                => intval($row->id),
                'booking_id'        => $row->booking_id,
                'order_type'        => $row->order_type,
                'user_id'           => intval($row->user_id),
                'main_data_id'      => intval($row->main_data_id),
                'cat_id'            => intval($row->cat_id),
                'address_id'        => intval($row->address_id),
                'name'              => $row->name,
                'mobile'            => intval($row->mobile),
                'user_image'        => $row->user_image,
                'fee'               => intval($row->fee),
                'consultation_fee'  => intval($row->consultation_fee),
                'coupon_id'         => intval($row->coupon_id),
                'coupon_percentage' => intval($row->coupon_percentage),
                'coupon_discount'   => intval($row->coupon_discount),
                'payment_type'      => $row->payment_type,
                'order_type'        => $row->order_type,
                'booking_type'      => $row->booking_type,
                'booking_status'    => $row->booking_status,
                'accept_status'     => $row->accept_status,
                'created_on'        => $row->created_on,
                'hospital_name'     => $row->hospital_name,
                'products'          => []
            ];
        }
        $result[$id]['products'][] = [
            'hospital_name'     => $row->hospital_name,
            'product_name' => $row->product_name,
            'image' => $row->image,
            'price' => intval($row->price),
            'original_price' => intval($row->original_price),
            'cart_quantity'  => intval($row->cart_quantity)
        ];
    }

    return array_values($result);
}
public function get_hospital_pharmacy_single_medicine_orders($booking_id){
    $this->db->select('pb.id,pb.booking_id, pb.created_on, pb.order_type, pb.user_id, pb.main_data_id, pb.address_id, pb.mobile, pb.name,pb.booking_status,pb.order_type,pb.booking_type, pb.accept_status,pb.image,u.image as user_image,md.name as hospital_name');
    $this->db->from('hospital_pharmacy_medicine_orders pb');
    $this->db->join('users u', 'u.id = pb.user_id', 'left');
    $this->db->join('main_data md', 'md.id = pb.main_data_id', 'left');
    $this->db->where('pb.booking_id', $booking_id);
    $this->db->order_by('pb.created_on', 'DESC');

    $query = $this->db->get();
    $raw = $query->result();

    // Group by booking ID to avoid duplication
    $result = [];
    foreach ($raw as $row) {
        $id = $row->booking_id;
        if (!isset($result[$id])) {
            $result[$id] = [
                'id'                => intval($row->id),
                'booking_id'        => $row->booking_id,
                'image'             => $row->image,
                'order_type'        => $row->order_type,
                'user_id'           => intval($row->user_id),
                'main_data_id'      => intval($row->main_data_id),
                'address_id'        => intval($row->address_id),
                'name'              => $row->name,
                'mobile'            => intval($row->mobile),
                'user_image'        => $row->user_image,
                'booking_type'      => $row->booking_type,
                'booking_status'    => $row->booking_status,
                'accept_status'     => $row->accept_status,
                'hospital_name'     => $row->hospital_name,
                'created_on'        => $row->created_on
            ];
        }
    }

    return array_values($result);
}
/*hospital_pharmacy_module*/

/*online_doctors*/
public function get_online_doctors($speciality_id, $limit, $offset) {
    // Select fields and aggregate functions
    $this->db->select(' online_doctors.*, SUM(online_doctor_ratings.rating) AS total_rating, COUNT(online_doctor_ratings.id) AS total_reviews, COUNT(online_doctor_bookings.id) AS consultations, GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification,odc.name as specialization ')->from('online_doctors');

    // Apply filters for speciality, active status, and delete status
    // Filters
    $this->db->where([
        'online_doctors.speciality_id' => $speciality_id,
        'online_doctors.status' => 1,
        'online_doctors.delete_status' => 1,
        'online_doctors.availability' => 1
    ]);
    
    // Joins
    $this->db->join('online_doctor_ratings', 'online_doctor_ratings.doctor_id = online_doctors.id', 'left');
    $this->db->join('online_doctor_bookings', 'online_doctor_bookings.doctor_id = online_doctors.id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, online_doctors.qualification)', 'left');
    $this->db->join('online_doctor_specialities odc', 'odc.id = online_doctors.speciality_id', 'left');
    // Group and sort
    $this->db->limit($limit, $offset);
    $this->db->group_by('online_doctors.id');
    $this->db->order_by('online_doctors.id', 'desc');
    
    $query = $this->db->get();
    $result = $query->result_array();
    
    // Map data
    return array_map(function ($row) {
        $total_rating = floatval($row['total_rating']);
        $total_reviews = intval($row['total_reviews']);
        $average_rating = ($total_reviews > 0) ? number_format($total_rating / $total_reviews, 1) : "0.0";
    
        return [
            'id'                => intval($row['id']),
            'unique_id'         => $row['unique_id'],
            'speciality_id'     => intval($row['speciality_id']),
            'name'              => $row['name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => $row['exp'],
            'description'       => $row['description'],
            'fee'               => intval($row['fee']),
            'rating'            => $average_rating,
            'total_reviews'     => $total_reviews,
            'consultations'     => intval($row['consultations']),
        ];
    }, $result);

}
public function get_online_doctors_rows($speciality_id) {
    $this->db->from('online_doctors');
    $this->db->where(['speciality_id' => $speciality_id,'status' => 1,'delete_status' => 1,'availability' => 1]);
    return $this->db->count_all_results();
}
public function get_online_doctor_dates($speciality_id, $doctor_id){
    $today = date('Y-m-d');

    $this->db->select('DISTINCT(date)', false);
    $this->db->from('online_doctor_slots');
    $this->db->where('speciality_id', $speciality_id);
    $this->db->where('doctor_id', $doctor_id);
    $this->db->where('date >=', $today);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);
    $this->db->order_by('date', 'ASC');
    
    $query = $this->db->get();
    $result = $query->result_array();

    // Format the dates
    $dates = array_map(function($row) {
        return [
            'date' => $row['date'],
            'format_date' => date('D d M', strtotime($row['date']))
        ];
    }, $result);

    return $dates;
}
public function get_online_doctor_slots($speciality_id, $doctor_id, $date, $user_id) {
    $today = date('Y-m-d');
    $current_time_24hr = date('H:i');

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('online_doctor_slots');
    $this->db->where('speciality_id', $speciality_id);
    $this->db->where('doctor_id', $doctor_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // Filter only future slots if date is today
    if ($date == $today) {
        $this->db->where("STR_TO_DATE(time, '%h:%i %p') >=", $current_time_24hr);
    }

    $this->db->order_by("STR_TO_DATE(time, '%h:%i %p')", "ASC", false);

    $query = $this->db->get();
    $raw_slots = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    $added_times = []; // To avoid duplicates

    foreach ($raw_slots as $row) {
        $time_24hr = date('H:i', strtotime($row['time']));
        if (in_array($row['time'], $added_times)) continue; // prevent duplicates
        $added_times[] = $row['time'];

        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        if ($time_24hr >= 0 && $time_24hr < 12) {
            $slots['morning'][] = $row;
        } elseif ($time_24hr >= 12 && $time_24hr < 17) {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    // Get family members
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    foreach ($family_members as &$member) {
        $member['id'] = (int) $member['id'];
    }

    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
public function online_doctor_bookings_history_active($user_id, $limit, $offset) {
    $this->db->select(' b.id,  b.booking_id,b.consult_type,b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, s.name AS speciality_name, d.name AS doctor_name, d.unique_id, d.image, d.exp, d.specialization, GROUP_CONCAT(md.name ORDER BY md.name SEPARATOR ", ") AS qualification, fm.email, fm.gender, fm.dob, (SELECT COUNT(*) FROM online_doctor_bookings WHERE doctor_id = b.doctor_id) AS consultations,odc.name as specialization ');

    $this->db->from('online_doctor_bookings b');
    $this->db->join('online_doctor_specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('online_doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    $this->db->join('online_doctor_specialities odc', 'odc.id = d.speciality_id', 'left');
    // Filtering
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'booked');
    
    // Grouping to avoid duplicates due to multiple degrees
    $this->db->group_by('b.id');
    
    // Pagination & Sorting
    $this->db->limit($limit, $offset);
    $this->db->order_by('b.id', 'desc');
    
    $query = $this->db->get();
    $result = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => $row['date'],
            'mobile'            => intval($row['mobile']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            //'speciality_name'   => $row['speciality_name'],
            'unique_id'         => $row['unique_id'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => $row['exp'],
            'consultations'     => intval($row['consultations']),
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
        ];
    }, $result);

}
public function online_doctor_bookings_history_active_rows($user_id) {
    $this->db->from('online_doctor_bookings b');
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'booked');
    return $this->db->count_all_results();
}
public function online_doctor_bookings_history_completed($user_id, $limit, $offset) {
    $this->db->select('b.id, b.booking_id,b.consult_type,b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, d.name AS doctor_name, d.unique_id, d.image, d.exp, d.specialization, GROUP_CONCAT(md.name ORDER BY md.name SEPARATOR ", ") AS qualification, fm.email, fm.gender, fm.dob, (SELECT COUNT(*) FROM online_doctor_bookings WHERE doctor_id = b.doctor_id) AS consultations,odc.name as specialization ');

    $this->db->from('online_doctor_bookings b');
    $this->db->join('online_doctor_specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('online_doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    $this->db->join('online_doctor_specialities odc', 'odc.id = d.speciality_id', 'left');
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    
    $this->db->group_by('b.id');
    $this->db->limit($limit, $offset);
    $this->db->order_by('b.id', 'desc');
    
    $query = $this->db->get();
    $result = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => $row['date'],
            'mobile'            => intval($row['mobile']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            //'speciality_name'   => $row['speciality_name'],
            'unique_id'         => $row['unique_id'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => $row['exp'],
            'consultations'     => intval($row['consultations']),
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
        ];
    }, $result);

}
public function online_doctor_bookings_history_completed_rows($user_id) {
    $this->db->from('online_doctor_bookings b');
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    return $this->db->count_all_results();
}
public function online_doctor_single_booking_history_completed($booking_id) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.payment_type, b.patient_name, b.booking_status, s.name AS specialization, d.name AS doctor_name, d.exp, COUNT(b.id) AS consultations, GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification,fm.email, fm.gender, fm.dob, d.image, bg.name as blood_group');

    $this->db->from('online_doctor_bookings b');
    $this->db->join('online_doctor_specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('online_doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    $this->db->where('b.booking_id', $booking_id);
    //$this->db->where('b.booking_status', 'completed');
    $this->db->group_by('b.id');
    $this->db->order_by('b.id', 'DESC');
    //$this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    $final_result = [];

    foreach ($result as $row) {
        $booking_id = $row['booking_id'];

        // Fetch medicines
        $medicines = $this->db
        ->select('medicine, medicine_time')
        ->get_where('online_doctor_booking_medicines', ['booking_id' => $booking_id])
        ->result_array();

        
        // Fetch tests
        $tests = $this->db
        ->select('test, test_instruction')
        ->get_where('online_doctor_booking_tests', ['booking_id' => $booking_id])
        ->result_array();
        
        // Fetch notes
        
        $notes = $this->db
            ->select('notes')
            ->get_where('online_doctor_booking_notes', ['booking_id' => $booking_id])
            ->result_array();
        
        // Extract just the 'notes' values into a simple array
        $note_values = array_column($notes, 'notes');
        
        // Assign directly to your output array
        $data = $note_values;

        $final_result[] = [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'payment_type'      => $row['payment_type'],
            'specialization'    => $row['specialization'],
            'name'              => $row['doctor_name'],
            'exp'               => intval($row['exp']),
            'consultations'     => intval($row['consultations']),
            'qualification'     => $row['qualification'],
            'image'             => $row['image'],
            'booking_status'    => $row['booking_status'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group'],
            'medicines'         => !empty($medicines) ? $medicines : [],
            'tests'             => !empty($tests) ? $tests : [],
            'notes'             => !empty($notes) ? $data : []
        ];
    }

    return $final_result;
}
/*online_doctors*/

/*diagnostics*/
public function get_diagnostics_main_data_first($lat, $lon, $radius, $limit, $offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        diagnostics.id,diagnostics.name,diagnostics.open_time,diagnostics.close_time,diagnostics.logo,diagnostics.location,diagnostics.lat,diagnostics.lon", false);
    $this->db->from('diagnostics');
    
    // Filters
    $this->db->where('diagnostics.status', 1);
    $this->db->where('diagnostics.delete_status', 1);
    $this->db->where('diagnostics.availability', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('diagnostics.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'            => intval($row['id']),
            'name'          => $row['name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'lat'           => $row['lat'],
            'lon'           => $row['lon'],
        ];
    }, $result);
}
public function get_diagnostics_data_first_rows($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        diagnostics.id,diagnostics.name,diagnostics.open_time,diagnostics.close_time,diagnostics.logo,diagnostics.location,diagnostics.lat,diagnostics.lon", false);
    $this->db->from('diagnostics');
    
    // Filters
    $this->db->where('diagnostics.status', 1);
    $this->db->where('diagnostics.delete_status', 1);
    $this->db->where('diagnostics.availability', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('diagnostics.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    return $result;
}
public function get_search_diagnostics_main_data_first($lat, $lon, $search, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        diagnostics.id, diagnostics.name, diagnostics.open_time, diagnostics.close_time,
        diagnostics.logo, diagnostics.location, diagnostics.lat, diagnostics.lon", false);

    $this->db->from('diagnostics');

    // Status filters
    $this->db->where('diagnostics.status', 1);
    $this->db->where('diagnostics.delete_status', 1);
    $this->db->where('diagnostics.availability', 1);

    // Multilingual name search (name_en, name_hi, name_te)
    $this->db->like('diagnostics.name', $search);

    // Distance filter
    $this->db->having('distance <=', $radius);

    // Grouping & ordering
    $this->db->group_by('diagnostics.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'            => intval($row['id']),
            'name'          => $row['name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'lat'           => $row['lat'],
            'lon'           => $row['lon'],
        ];
    }, $result);
}
public function get_diagnostic_tests($diagnostic_id, $limit, $offset) {
    // Step 1: Get package IDs
    $this->db->select("id");
    $this->db->from("diagnostic_packages");
    $this->db->where("main_data_id", $diagnostic_id);
    $this->db->where("status", 1);
    $this->db->where("delete_status", 1);
    $this->db->order_by("id", "desc");
    $this->db->limit($limit, $offset);
    $package_query = $this->db->get();
    $package_ids = array_column($package_query->result_array(), 'id');

    if (empty($package_ids)) {
        return []; // No packages found
    }

    // Step 2: Get all related tests and sub-tests
    $this->db->select("
        diagnostic_packages.id AS package_id,
        diagnostic_packages.name,
        diagnostic_packages.image,
        diagnostic_packages.one_person,
        diagnostic_packages.one_person_discount,
        diagnostic_packages.report_in,
        diagnostic_packages.fasting,
        diagnostic_tests.id AS test_id,
        diagnostic_tests.name AS test_name,
        diagnostic_sub_tests.id AS sub_test_id,
        diagnostic_sub_tests.name AS sub_test_name
    ");
    $this->db->from('diagnostic_packages');
    $this->db->join('diagnostic_tests', 'diagnostic_tests.package_id = diagnostic_packages.id AND diagnostic_tests.main_data_id = diagnostic_packages.main_data_id AND diagnostic_tests.status = 1 AND diagnostic_tests.delete_status = 1', 'left');
    $this->db->join('diagnostic_sub_tests', 'diagnostic_sub_tests.test_id = diagnostic_tests.id AND diagnostic_sub_tests.package_id = diagnostic_tests.package_id AND diagnostic_sub_tests.main_data_id = diagnostic_tests.main_data_id AND diagnostic_sub_tests.status = 1 AND diagnostic_sub_tests.delete_status = 1', 'left');
    $this->db->where_in('diagnostic_packages.id', $package_ids);
    $this->db->where('diagnostic_packages.main_data_id', $diagnostic_id);
    $this->db->where('diagnostic_packages.status', 1);
    $this->db->where('diagnostic_packages.delete_status', 1);
    $this->db->order_by('diagnostic_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Step 3: Process data
    $final_data = [];

    foreach ($result as $row) {
        $package_id = $row['package_id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($package_id),
                'name' => $row['name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'tests' => []
            ];
        }

        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        if ($sub_test_id && isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert associative test arrays to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
public function get_diagnostic_tests_rows($diagnostic_id){
    $this->db->from('diagnostic_packages');
    $this->db->where(['main_data_id' => $diagnostic_id,'status' => 1,'delete_status' => 1]);
    return $this->db->count_all_results();
}
public function get_diagnostic_dates($diagnostic_id) {
    $today = date('Y-m-d');

    $this->db->select('DISTINCT(date)', false);
    $this->db->from('diagnostic_slots');
    $this->db->where('main_data_id', $diagnostic_id);
    $this->db->where('date >=', $today);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);
    $this->db->order_by('date', 'ASC');
    
    $query = $this->db->get();
    $result = $query->result_array();

    // Format the dates
    $dates = array_map(function($row) {
        return [
            'date' => $row['date'],
            'format_date' => date('D d M', strtotime($row['date']))
        ];
    }, $result);

    return $dates;
}
public function get_diagnostic_slots($diagnostic_id,$date,$user_id) {
    $today = date('Y-m-d');
    $current_time_24hr = date('H:i');

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('diagnostic_slots');
    $this->db->where('main_data_id', $diagnostic_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // Filter only future slots if date is today
    if ($date == $today) {
        $this->db->where("STR_TO_DATE(time, '%h:%i %p') >=", $current_time_24hr);
    }

    $this->db->order_by("STR_TO_DATE(time, '%h:%i %p')", "ASC", false);

    $query = $this->db->get();
    $raw_slots = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    $added_times = []; // To avoid duplicates

    foreach ($raw_slots as $row) {
        $time_24hr = date('H:i', strtotime($row['time']));
        if (in_array($row['time'], $added_times)) continue; // prevent duplicates
        $added_times[] = $row['time'];

        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        if ($time_24hr >= 0 && $time_24hr < 12) {
            $slots['morning'][] = $row;
        } elseif ($time_24hr >= 12 && $time_24hr < 17) {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    // Get family members
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    foreach ($family_members as &$member) {
        $member['id'] = (int) $member['id'];
    }

    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
public function get_single_diagnostic_tests($test_id) {
    // Step 1: Get package IDs
    $this->db->select("id");
    $this->db->from("diagnostic_packages");
    $this->db->where("id", $test_id);
    /*$this->db->where("status", 1);
    $this->db->where("delete_status", 1);*/
    $this->db->order_by("id", "desc");
    $this->db->limit($limit, $offset);
    $package_query = $this->db->get();
    $package_ids = array_column($package_query->result_array(), 'id');

    if (empty($package_ids)) {
        return []; // No packages found
    }

    // Step 2: Get all related tests and sub-tests
    $this->db->select("
        diagnostic_packages.id AS package_id,
        diagnostic_packages.name,
        diagnostic_packages.image,
        diagnostic_packages.one_person,
        diagnostic_packages.one_person_discount,
        diagnostic_packages.report_in,
        diagnostic_packages.fasting,
        diagnostic_tests.id AS test_id,
        diagnostic_tests.name AS test_name,
        diagnostic_sub_tests.id AS sub_test_id,
        diagnostic_sub_tests.name AS sub_test_name,
        diagnostics.location
    ");
    $this->db->from('diagnostic_packages');
    $this->db->join('diagnostic_tests', 'diagnostic_tests.package_id = diagnostic_packages.id AND diagnostic_tests.main_data_id = diagnostic_packages.main_data_id AND diagnostic_tests.status = 1 AND diagnostic_tests.delete_status = 1', 'left');
    $this->db->join('diagnostic_sub_tests', 'diagnostic_sub_tests.test_id = diagnostic_tests.id AND diagnostic_sub_tests.package_id = diagnostic_tests.package_id AND diagnostic_sub_tests.main_data_id = diagnostic_tests.main_data_id AND diagnostic_sub_tests.status = 1 AND diagnostic_sub_tests.delete_status = 1', 'left');
    $this->db->join('diagnostics','diagnostics.id=diagnostic_packages.main_data_id','left');
    $this->db->where_in('diagnostic_packages.id', $package_ids);
    $this->db->where('diagnostic_packages.id', $test_id);
    $this->db->where('diagnostic_packages.status', 1);
    $this->db->where('diagnostic_packages.delete_status', 1);
    $this->db->order_by('diagnostic_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Step 3: Process data
    $final_data = [];

    foreach ($result as $row) {
        $package_id = $row['package_id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($package_id),
                'name' => $row['name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'location' => $row['location'],
                'tests' => []
            ];
        }

        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        if ($sub_test_id && isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert associative test arrays to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
public function save_diagnostic_booking_snapshot($booking_id, $diagnostic_data) {
    foreach ($diagnostic_data as $package) {
        // 1. Insert into booking_diagnostic_packages
        $package_data = [
            'booking_id' => $booking_id,
            'name' => $package['name'],
            'image' => $package['image'],
            'one_person' => $package['one_person'],
            'one_person_discount' => $package['one_person_discount'],
            'report_in' => $package['report_in'],
            'fasting' => $package['fasting'],
            'location' => $package['location'],
            'created_on'    => date('Y-m-d H:i:s')
        ];
        $this->db->insert('diagnostic_booking_packages', $package_data);
        $booking_package_id = $this->db->insert_id();

        foreach ($package['tests'] as $test) {
            // 2. Insert into booking_diagnostic_tests
            $test_data = [
                'booking_id' => $booking_id,
                'booking_package_id' => $booking_package_id,
                'name' => $test['name'],
                'created_on'    => date('Y-m-d H:i:s')
            ];
            $this->db->insert('diagnostic_booking_tests', $test_data);
            $booking_test_id = $this->db->insert_id();

            foreach ($test['sub_tests'] as $sub_test) {
                // 3. Insert into booking_diagnostic_subtests
                $subtest_data = [
                    'booking_id' => $booking_id,
                    'booking_test_id' => $booking_test_id,
                    'name' => $sub_test['name'],
                    'created_on'    => date('Y-m-d H:i:s')
                ];
                $this->db->insert('diagnostic_booking_subtests', $subtest_data);
            }
        }
    }
}
public function get_diagnostic_bookings($user_id) {
    $this->db->select('db.id, db.booking_id, db.created_on, db.user_id, db.main_data_id, db.slot_id, db.date, db.time, db.booking_status, db.booking_type, d.name as diagnostic_name, d.logo, d.open_time, d.close_time, d.location');
    $this->db->from('diagnostic_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'booked');

    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('db.accept_status', 'accepted');
    $this->db->or_where('db.accept_status', '');
    $this->db->group_end();

    $this->db->join('diagnostics d','d.id=db.main_data_id','left');
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $bookings = $query->result_array();

    // Now for each booking, fetch related packages, tests, subtests
    foreach ($bookings as &$booking) {
        $booking_id = $booking['booking_id'];

        // Reset query builder before new query
        $this->db->reset_query();

        $this->db->select("
            p.id AS package_id, p.name AS package_name, 
            p.report_in, p.fasting

        ");
        $this->db->from('diagnostic_booking_packages p');
        $this->db->where('p.booking_id', $booking_id);

        $query2 = $this->db->get();
        $rows = $query2->result_array();

        // Organize package data grouped by package_id, including tests and subtests
        $packages = [];
        foreach ($rows as $row) {
            $pkg_id = $row['package_id'];
            if (!isset($packages[$pkg_id])) {
                $packages[$pkg_id] = [
                    'package_id' => $row['package_id'],
                    'package_name' => $row['package_name'],
                    'report_in' => $row['report_in'],
                    'fasting' => $row['fasting']
                ];
            }

            // Add test info if exists
            
        }

        

        $booking['packages'] = array_values($packages);
    }

    // Format and return bookings with attached packages/tests/subtests
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => intval($row['slot_id']),
            'date' => $row['date'],
            'time' => $row['time'],
            'booking_status' => $row['booking_status'],
            'booking_type' => $row['booking_type'],
            'packages' => isset($row['packages']) ? $row['packages'][0] : (object)[]
        ];
    }, $bookings);
}
public function get_diagnostic_prescription_orders($user_id){
    $this->db->select('dpb.id, dpb.booking_id, dpb.created_on,dpb.user_id,dpb.main_data_id,dpb.image,dpb.accept_status,d.name as diagnostic_name,d.logo,d.open_time,d.close_time,d.location,dpb.booking_status,dpb.booking_type,');
    $this->db->from('diagnostic_prescription_bookings dpb');
    $this->db->where(['user_id' => $user_id,'booking_status' => 'booked']);
    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('accept_status', 'accepted');
    $this->db->or_where('accept_status', '');
    $this->db->group_end();
    $this->db->join('diagnostics d','d.id=dpb.main_data_id','left');
    $this->db->order_by('dpb.id', 'DESC');

    $query = $this->db->get();
    $orders = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => 0,
            'date' => '',
            'time' => '',
            'booking_status' => $row['booking_status'],
            'booking_type'      => $row['booking_type'],
            'packages' => (object)[]
        ];
    }, $orders);
}
public function diagnostic_combined_orders($user_id, $limit, $offset,$page){
    $product_orders = $this->get_diagnostic_bookings($user_id);
    $prescription_orders = $this->get_diagnostic_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    if(!empty($combined)){
        /*usort($combined, function($a, $b) {
            //return strtotime($b->id ?? $b['id']) - strtotime($a->created_on ?? $a['created_on']);
        });*/
    
        // Pagination manually
        $paged_orders = array_slice($combined, $offset, $limit);
    
        $total_pages   = ceil(count($combined) / $limit);
        $pages = [];
    
        for ($t = 1; $t <= $total_pages; $t++) {
            $pages[] = ['page' => $t];
        }
    
        return [
            'history' => $paged_orders,
            'pagination' => [
                'total_pages'  => $pages,
                'current_page' => $page,
                'limit'        => $limit
            ]
        ];
    }else{
        return [];
    }
}
public function get_completed_diagnostic_bookings($user_id) {
    $this->db->select('db.id, db.booking_id, db.created_on, db.user_id, db.main_data_id, db.slot_id, db.date,db.time, db.booking_status, db.booking_type, d.name as diagnostic_name, d.logo, d.open_time, d.close_time, d.location');
    $this->db->from('diagnostic_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'completed');

    $this->db->join('diagnostics d','d.id=db.main_data_id','left');
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $bookings = $query->result_array();

    foreach ($bookings as &$booking) {
        $booking_id = $booking['booking_id'];

        $this->db->reset_query();

        $this->db->select("
            p.id AS package_id, p.name AS package_name,
            p.report_in, p.fasting
        ");
        $this->db->from('diagnostic_booking_packages p');
        $this->db->where('p.booking_id', $booking_id);

        $query2 = $this->db->get();
        $rows = $query2->result_array();

        $packages = [];
        foreach ($rows as $row) {
            $pkg_id = $row['package_id'];
            if (!isset($packages[$pkg_id])) {
                $packages[$pkg_id] = [
                    'package_id' => $row['package_id'],
                    'package_name' => $row['package_name'],
                    'report_in' => $row['report_in'],
                    'fasting' => $row['fasting']
                ];
            }

        }

        $booking['packages'] = array_values($packages);
    }

    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id' => $row['booking_id'],
            'created_on' => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => intval($row['slot_id']),
            'date' => $row['date'],
            'time' => $row['time'],
            'slot_id' => intval($row['slot_id']),
            'date' => $row['date'],
            'time' => $row['time'],
            'booking_status' => $row['booking_status'],
            'booking_type' => $row['booking_type'],
            'packages' => isset($row['packages']) ? $row['packages'][0] : (object)[]
        ];
    }, $bookings);
}
public function get_completed_diagnostic_prescription_orders($user_id){
    $this->db->select('dpb.id, dpb.booking_id, dpb.created_on,dpb.user_id,dpb.main_data_id,dpb.image,dpb.accept_status,d.name as diagnostic_name,d.logo,d.open_time,d.close_time,d.location,dpb.booking_status,dpb.booking_type,');
    $this->db->from('diagnostic_prescription_bookings dpb');
    $this->db->where(['user_id' => $user_id,'booking_status' => 'completed']);
    $this->db->join('diagnostics d','d.id=dpb.main_data_id','left');
    $this->db->order_by('dpb.id', 'DESC');

    $query = $this->db->get();
    $orders = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => 0,
            'date' => '',
            'time' => '',
            'booking_status' => $row['booking_status'],
            'booking_type'      => $row['booking_type'],
            'packages' => (object)[]
        ];
    }, $orders);
}
public function diagnostic_completed_combined_orders($user_id, $limit, $offset, $page){
    $product_orders = $this->get_completed_diagnostic_bookings($user_id);
    $prescription_orders = $this->get_completed_diagnostic_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    /*usort($combined, function($a, $b) {
        //return strtotime($b->id ?? $b['id']) - strtotime($a->created_on ?? $a['created_on']);
    });*/

    // Pagination manually
    $paged_orders = array_slice($combined, $offset, $limit);
    
    $total_pages   = ceil(count($combined) / $limit);
    $pages = [];

    for ($t = 1; $t <= $total_pages; $t++) {
        $pages[] = ['page' => $t];
    }

    return [
        'history' => $paged_orders,
        'pagination' => [
            'total_pages'  => $pages,
            'current_page' => $page,
            'limit'        => $limit
        ]
    ];
}
public function single_diagnostic_booking_details($booking_id){
    // Step 1: Get main booking info
    $this->db->select('
        db.id, db.booking_id, db.user_id, db.main_data_id, db.slot_id, db.date, db.time,db.accept_status,db.booking_status,db.booking_type,
        db.booking_status, db.test_status, db.image, db.count, db.fee, db.consultation_fee,  db.coupon_id, db.coupon_name,
         db.coupon_percentage, db.coupon_discount, db.payment_type, db.transaction_id, hdbp.name,db.family_member_id,db.mobile,d.name as diagnostic_name,d.logo,d.location,d.lat,d.lon,
    (
            (SELECT COUNT(*) FROM diagnostic_booking_tests hdbt WHERE hdbt.booking_id = db.booking_id) +
            (SELECT COUNT(*) FROM diagnostic_booking_subtests hdbst WHERE hdbst.booking_id = db.booking_id)
        ) AS total_test_count');
    $this->db->from('diagnostic_bookings db');
    $this->db->join('diagnostic_booking_packages hdbp', 'hdbp.booking_id = db.booking_id', 'left');
    $this->db->join('diagnostics d', 'd.id = db.main_data_id', 'left');
    //$this->db->join('diagnostic_reports hdr', 'hdr.booking_id = db.booking_id and hdr.booking_type=db.booking_type', 'left');
    $this->db->where('db.booking_id', $booking_id);
    $booking = $this->db->get()->row_array();

    if (!$booking) return null;

    // Cast integers
    $booking['id'] = intval($booking['id']);
    $booking['user_id'] = intval($booking['user_id']);
    $booking['main_data_id'] = intval($booking['main_data_id']);
    $booking['diagnostic_id'] = intval($booking['main_data_id']);
    $booking['slot_id'] = intval($booking['slot_id']);
    $booking['count'] = intval($booking['count']);
    $booking['fee'] = intval($booking['fee']);
    $booking['consultation_fee'] = intval($booking['consultation_fee']);
    $booking['coupon_id'] = intval($booking['coupon_id']);
    $booking['coupon_percentage'] = intval($booking['coupon_percentage']);
    $booking['coupon_discount'] = intval($booking['coupon_discount']);
    $booking['total_test_count'] = intval($booking['total_test_count']);
    $booking['mobile'] = intval($booking['mobile']);
    
    $reports = [];
    //if (!empty($booking['family_member_id'])) {
        $this->db->select('image');
        $this->db->from('diagnostic_reports');
        $this->db->where(['booking_id' => $booking['booking_id'],'booking_type' => $booking['booking_type']]);
        $reports = $this->db->get()->result_array();
    //}
    $booking['reports'] = $reports;
    
    // Step 2: Get family members (if any)
    $family_members = [];
    if (!empty($booking['family_member_id'])) {
        $ids = explode(',', $booking['family_member_id']);
        $clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        if (!empty($clean_ids)) {
            $this->db->select('id, name, dob, gender, email, mobile');
            $this->db->from('family_members');
            $this->db->where_in('id', $clean_ids);
            $family_members = $this->db->get()->result_array();
            foreach ($family_members as &$member) {
                $member['id']       = intval($member['id']);
                $member['mobile']   = intval($member['mobile']);
            }
        }
    }
    $booking['family_members'] = $family_members;

    // Step 3: Join all booking-related data in one query
    $this->db->select("
        p.id AS package_id, p.name AS package_name, p.image, p.one_person, p.one_person_discount,
        p.report_in, p.fasting, p.location AS package_location,

        t.id AS test_id, t.name AS test_name,
        st.id AS sub_test_id, st.name AS sub_test_name
    ");
    $this->db->from('diagnostic_booking_packages p');
    $this->db->join('diagnostic_booking_tests t', 't.booking_package_id = p.id AND t.booking_id = p.booking_id', 'left');
    $this->db->join('diagnostic_booking_subtests st', 'st.booking_test_id = t.id AND st.booking_id = t.booking_id', 'left');
    $this->db->where('p.booking_id', $booking_id);
    $query = $this->db->get();
    $rows = $query->result_array();

    // Step 4: Group data
    $packages = [];
    foreach ($rows as $row) {
        $pkg_id = intval($row['package_id']);
        if (!isset($packages[$pkg_id])) {
            $packages[$pkg_id] = [
                'id' => $pkg_id,
                'name' => $row['package_name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'location' => $row['package_location'],
                'tests' => []
            ];
        }

        $test_id = intval($row['test_id']);
        if ($test_id && !isset($packages[$pkg_id]['tests'][$test_id])) {
            $packages[$pkg_id]['tests'][$test_id] = [
                'id' => $test_id,
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        $sub_test_id = intval($row['sub_test_id']);
        if ($sub_test_id && isset($packages[$pkg_id]['tests'][$test_id])) {
            $packages[$pkg_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => $sub_test_id,
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Final formatting
    foreach ($packages as &$pkg) {
        $pkg['tests'] = array_values($pkg['tests']);
    }

    $booking['packages'] = array_values($packages);
    unset($booking['main_data_id'], $booking['family_member_ids']); // Clean up

    return $booking;
}
public function single_diagnostic_prescription_orders($booking_id){
    // Step 1: Get main booking info
    $this->db->select('
        db.id, db.booking_id, db.user_id, db.main_data_id, db.image,db.name,db.mobile,db.accept_status,db.booking_status,db.booking_type,
        db.booking_status, db.image, d.name as diagnostic_name,d.logo, db.family_member_id,
        d.open_time, d.close_time, d.location,d.lat,d.lon
    ');
    $this->db->from('diagnostic_prescription_bookings db');
    $this->db->join('diagnostics d', 'd.id = db.main_data_id', 'left');
    //$this->db->join('diagnostic_reports hdr', 'hdr.booking_id = db.booking_id and hdr.booking_type=db.booking_type', 'left');
    $this->db->where('db.booking_id', $booking_id);
    $booking = $this->db->get()->row_array();

    if (!$booking) return null;

    // Cast integers
    $booking['id'] = intval($booking['id']);
    $booking['user_id'] = intval($booking['user_id']);
    $booking['main_data_id'] = intval($booking['main_data_id']);
    $booking['diagnostic_id'] = intval($booking['main_data_id']);
    $booking['mobile'] = intval($booking['mobile']);
    
    $reports = [];
    //if (!empty($booking['family_member_id'])) {
        $this->db->select('image');
        $this->db->from('diagnostic_reports');
        $this->db->where(['booking_id' => $booking['booking_id'],'booking_type' => $booking['booking_type']]);
        $reports = $this->db->get()->result_array();
    //}
    $booking['reports'] = $reports;
    
    // Step 2: Get family members (if any)
    $family_members = [];
    if (!empty($booking['family_member_id'])) {
        $ids = explode(',', $booking['family_member_id']);
        $clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        if (!empty($clean_ids)) {
            $this->db->select('id, name, dob, gender, email');
            $this->db->from('family_members');
            $this->db->where_in('id', $clean_ids);
            $family_members = $this->db->get()->result_array();
            foreach ($family_members as &$member) {
                $member['id'] = intval($member['id']);
            }
        }
    }
    $booking['family_members'] = $family_members;

    unset($booking['main_data_id'], $booking['family_member_id']); // Clean up

    return $booking;
}
/*diagnostics*/

/*lab_tests*/
public function get_lab_tests_main_data_first($lat, $lon, $radius, $limit, $offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        lab_tests.id,lab_tests.name,lab_tests.open_time,lab_tests.close_time,lab_tests.logo,lab_tests.location,lab_tests.lat,lab_tests.lon", false);
    $this->db->from('lab_tests');
    
    // Filters
    $this->db->where('lab_tests.status', 1);
    $this->db->where('lab_tests.delete_status', 1);
    $this->db->where('lab_tests.availability', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('lab_tests.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'            => intval($row['id']),
            'name'          => $row['name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'lat'           => $row['lat'],
            'lon'           => $row['lon'],
        ];
    }, $result);
}
public function get_lab_tests_data_first_rows($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        lab_tests.id,lab_tests.name,lab_tests.open_time,lab_tests.close_time,lab_tests.logo,lab_tests.location,lab_tests.lat,lab_tests.lon", false);
    $this->db->from('lab_tests');
    
    // Filters
    $this->db->where('lab_tests.status', 1);
    $this->db->where('lab_tests.delete_status', 1);
    $this->db->where('lab_tests.availability', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('lab_tests.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    return $result;
}
public function get_search_lab_tests_main_data_first($lat, $lon, $search, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        lab_tests.id, lab_tests.name, lab_tests.open_time, lab_tests.close_time,
        lab_tests.logo, lab_tests.location, lab_tests.lat, lab_tests.lon", false);

    $this->db->from('lab_tests');

    // Status filters
    $this->db->where('lab_tests.status', 1);
    $this->db->where('lab_tests.delete_status', 1);
    $this->db->where('lab_tests.availability', 1);

    // Multilingual name search (name_en, name_hi, name_te)
    $this->db->like('lab_tests.name', $search);

    // Distance filter
    $this->db->having('distance <=', $radius);

    // Grouping & ordering
    $this->db->group_by('lab_tests.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id'            => intval($row['id']),
            'name'          => $row['name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'lat'           => $row['lat'],
            'lon'           => $row['lon'],
        ];
    }, $result);
}
public function get_lab_tests($lab_test_id, $limit, $offset){
    // Step 1: Get package IDs
    $this->db->select("id");
    $this->db->from("lab_packages");
    $this->db->where("main_data_id", $lab_test_id);
    $this->db->where("status", 1);
    $this->db->where("delete_status", 1);
    $this->db->order_by("id", "desc");
    $this->db->limit($limit, $offset);
    $package_query = $this->db->get();
    $package_ids = array_column($package_query->result_array(), 'id');

    if (empty($package_ids)) {
        return []; // No packages found
    }

    // Step 2: Get all related tests and sub-tests
    $this->db->select("
        lab_packages.id AS package_id,
        lab_packages.name,
        lab_packages.image,
        lab_packages.one_person,
        lab_packages.one_person_discount,
        lab_packages.report_in,
        lab_packages.fasting,
        lab_package_tests.id AS test_id,
        lab_package_tests.name AS test_name,
        lab_sub_tests.id AS sub_test_id,
        lab_sub_tests.name AS sub_test_name
    ");
    $this->db->from('lab_packages');
    $this->db->join('lab_package_tests', 'lab_package_tests.package_id = lab_packages.id AND lab_package_tests.main_data_id = lab_packages.main_data_id AND lab_package_tests.status = 1 AND lab_package_tests.delete_status = 1', 'left');
    $this->db->join('lab_sub_tests', 'lab_sub_tests.test_id = lab_package_tests.id AND lab_sub_tests.package_id = lab_package_tests.package_id AND lab_sub_tests.main_data_id = lab_package_tests.main_data_id AND lab_sub_tests.status = 1 AND lab_sub_tests.delete_status = 1', 'left');
    $this->db->where_in('lab_packages.id', $package_ids);
    $this->db->where('lab_packages.main_data_id', $lab_test_id);
    $this->db->where('lab_packages.status', 1);
    $this->db->where('lab_packages.delete_status', 1);
    $this->db->order_by('lab_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Step 3: Process data
    $final_data = [];

    foreach ($result as $row) {
        $package_id = $row['package_id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($package_id),
                'name' => $row['name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'tests' => []
            ];
        }

        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        if ($sub_test_id && isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert associative test arrays to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
public function get_lab_tests_rows($lab_test_id){
    $this->db->from('lab_packages');
    $this->db->where(['main_data_id' => $lab_test_id,'status' => 1,'delete_status' => 1]);
    return $this->db->count_all_results();
}
public function get_lab_test_dates($lab_test_id) {
    $today = date('Y-m-d');

    $this->db->select('DISTINCT(date)', false);
    $this->db->from('lab_test_slots');
    $this->db->where('main_data_id', $lab_test_id);
    $this->db->where('date >=', $today);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);
    $this->db->order_by('date', 'ASC');
    
    $query = $this->db->get();
    $result = $query->result_array();

    // Format the dates
    $dates = array_map(function($row) {
        return [
            'date' => $row['date'],
            'format_date' => date('D d M', strtotime($row['date']))
        ];
    }, $result);

    return $dates;
}
public function get_lab_test_slots($lab_test_id,$date,$user_id) {
    $today = date('Y-m-d');
    $current_time_24hr = date('H:i');

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('lab_test_slots');
    $this->db->where('main_data_id', $lab_test_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // Filter only future slots if date is today
    if ($date == $today) {
        $this->db->where("STR_TO_DATE(time, '%h:%i %p') >=", $current_time_24hr);
    }

    $this->db->order_by("STR_TO_DATE(time, '%h:%i %p')", "ASC", false);

    $query = $this->db->get();
    $raw_slots = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    $added_times = []; // To avoid duplicates

    foreach ($raw_slots as $row) {
        $time_24hr = date('H:i', strtotime($row['time']));
        if (in_array($row['time'], $added_times)) continue; // prevent duplicates
        $added_times[] = $row['time'];

        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        if ($time_24hr >= 0 && $time_24hr < 12) {
            $slots['morning'][] = $row;
        } elseif ($time_24hr >= 12 && $time_24hr < 17) {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    // Get family members
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    foreach ($family_members as &$member) {
        $member['id'] = (int) $member['id'];
    }

    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
public function get_single_lab_test($test_id) {
    // Step 1: Get package IDs
    $this->db->select("id");
    $this->db->from("lab_packages");
    $this->db->where("id", $test_id);
    /*$this->db->where("status", 1);
    $this->db->where("delete_status", 1);*/
    $this->db->order_by("id", "desc");
    $this->db->limit($limit, $offset);
    $package_query = $this->db->get();
    $package_ids = array_column($package_query->result_array(), 'id');

    if (empty($package_ids)) {
        return []; // No packages found
    }

    // Step 2: Get all related tests and sub-tests
    $this->db->select("
        lab_packages.id AS package_id,
        lab_packages.name,
        lab_packages.image,
        lab_packages.one_person,
        lab_packages.one_person_discount,
        lab_packages.report_in,
        lab_packages.fasting,
        lab_package_tests.id AS test_id,
        lab_package_tests.name AS test_name,
        lab_sub_tests.id AS sub_test_id,
        lab_sub_tests.name AS sub_test_name,
        lab_tests.location
    ");
    $this->db->from('lab_packages');
    $this->db->join('lab_package_tests', 'lab_package_tests.package_id = lab_packages.id AND lab_package_tests.main_data_id = lab_packages.main_data_id AND lab_package_tests.status = 1 AND lab_package_tests.delete_status = 1', 'left');
    $this->db->join('lab_sub_tests', 'lab_sub_tests.test_id = lab_package_tests.id AND lab_sub_tests.package_id = lab_package_tests.package_id AND lab_sub_tests.main_data_id = lab_package_tests.main_data_id AND lab_sub_tests.status = 1 AND lab_sub_tests.delete_status = 1', 'left');
    $this->db->join('lab_tests','lab_tests.id=lab_packages.main_data_id','left');
    $this->db->where_in('lab_packages.id', $package_ids);
    $this->db->where('lab_packages.id', $test_id);
    $this->db->where('lab_packages.status', 1);
    $this->db->where('lab_packages.delete_status', 1);
    $this->db->order_by('lab_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Step 3: Process data
    $final_data = [];

    foreach ($result as $row) {
        $package_id = $row['package_id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($package_id),
                'name' => $row['name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'location' => $row['location'],
                'tests' => []
            ];
        }

        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        if ($sub_test_id && isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert associative test arrays to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
public function save_lab_test_booking_snapshot($booking_id, $lab_test_data) {
    foreach ($lab_test_data as $package) {
        // 1. Insert into booking_diagnostic_packages
        $package_data = [
            'booking_id' => $booking_id,
            'name' => $package['name'],
            'image' => $package['image'],
            'one_person' => $package['one_person'],
            'one_person_discount' => $package['one_person_discount'],
            'report_in' => $package['report_in'],
            'fasting' => $package['fasting'],
            'location' => $package['location'],
            'created_on'    => date('Y-m-d H:i:s')
        ];
        $this->db->insert('lab_test_booking_packages', $package_data);
        $booking_package_id = $this->db->insert_id();

        foreach ($package['tests'] as $test) {
            // 2. Insert into booking_diagnostic_tests
            $test_data = [
                'booking_id' => $booking_id,
                'booking_package_id' => $booking_package_id,
                'name' => $test['name'],
                'created_on'    => date('Y-m-d H:i:s')
            ];
            $this->db->insert('lab_test_booking_tests', $test_data);
            $booking_test_id = $this->db->insert_id();

            foreach ($test['sub_tests'] as $sub_test) {
                // 3. Insert into booking_diagnostic_subtests
                $subtest_data = [
                    'booking_id' => $booking_id,
                    'booking_test_id' => $booking_test_id,
                    'name' => $sub_test['name'],
                    'created_on'    => date('Y-m-d H:i:s')
                ];
                $this->db->insert('lab_test_booking_subtests', $subtest_data);
            }
        }
    }
}
public function get_lab_test_bookings($user_id){
    $this->db->select('
        db.id,
        db.booking_id,
        db.created_on,
        db.user_id,
        db.main_data_id,
        db.slot_id,
        db.date,
        db.time,
        db.booking_status,
        db.booking_type,
        d.name as lab_test_name,
        d.logo,
        d.open_time,
        d.close_time,
        d.location,
        db.test_status,
        db.date
    ');
    $this->db->from('lab_test_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'booked');

    $this->db->group_start();
    $this->db->where('db.accept_status', 'accepted');
    $this->db->or_where('db.accept_status', '');
    $this->db->group_end();

    $this->db->join('lab_tests d','d.id=db.main_data_id','left');

    $today = date('Y-m-d');
    $this->db->order_by("CASE 
        WHEN db.date = '{$today}' THEN 0 
        ELSE 1 
    END", "ASC"); // Today comes first
    $this->db->order_by('db.date', 'DESC');

    $query = $this->db->get();
    $bookings = $query->result_array();

    // Now enrich each booking with its package/test/sub-test data
    foreach ($bookings as &$booking) {
        $booking_id = $booking['booking_id'];

        $this->db->select("
            p.id AS package_id, p.name AS package_name, p.image,
            p.report_in, p.fasting,

        ");
        $this->db->from('lab_test_booking_packages p');
        $this->db->where('p.booking_id', $booking_id);
        $package_query = $this->db->get();
        $package_data = $package_query->result_array();

        $booking['packages'] = $package_data[0];
    }

    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id'       => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name'          => $row['lab_test_name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'slot_id'       => intval($row['slot_id']),
            'date'          => $row['date'],
            'time'          => $row['time'],
            'booking_status'=> $row['booking_status'],
            'booking_type'  => $row['booking_type'],
            'test_status'   => $row['test_status'],
            'packages'      => $row['packages']
        ];
    }, $bookings);
}
public function get_lab_test_prescription_orders($user_id){
    $this->db->select('dpb.id, dpb.booking_id, dpb.created_on,dpb.user_id,dpb.main_data_id,dpb.image,dpb.accept_status,d.name as lab_test_name,d.logo,d.open_time,d.close_time,d.location,dpb.booking_status,dpb.booking_type,dpb.test_status');
    $this->db->from('lab_test_prescription_bookings dpb');
    $this->db->where(['user_id' => $user_id,'booking_status' => 'booked']);
    
    
    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('accept_status', 'accepted');
    $this->db->or_where('accept_status', '');
    $this->db->group_end();
    $this->db->join('lab_tests d','d.id=dpb.main_data_id','left');
    $this->db->order_by('dpb.id', 'DESC');

    $query = $this->db->get();
    $orders = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['lab_test_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id'       => 0,
            'date'          => '',
            'time'          => '',
            'booking_status' => $row['booking_status'],
            'booking_type'      => $row['booking_type'],
            'test_status'      => $row['test_status'],
            'packages'      => (object)array()
        ];
    }, $orders);
}
public function lab_test_combined_orders($user_id, $limit, $offset,$page){
    $product_orders = $this->get_lab_test_bookings($user_id);
    $prescription_orders = $this->get_lab_test_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    if(!empty($combined)){
        /*usort($combined, function($a, $b) {
            //return strtotime($b->id ?? $b['id']) - strtotime($a->created_on ?? $a['created_on']);
        });*/
    
        // Pagination manually
        $paged_orders = array_slice($combined, $offset, $limit);
    
        $total_pages   = ceil(count($combined) / $limit);
        $pages = [];
    
        for ($t = 1; $t <= $total_pages; $t++) {
            $pages[] = ['page' => $t];
        }
    
        return [
            'history' => $paged_orders,
            'pagination' => [
                'total_pages'  => $pages,
                'current_page' => $page,
                'limit'        => $limit
            ]
        ];
    }else{
        return [];
    }
}
public function get_completed_lab_test_bookings($user_id) {
    $this->db->select('
        db.id,
        db.booking_id,
        db.created_on,
        db.user_id,
        db.main_data_id,
        db.slot_id,
        db.date,
        db.time,
        db.booking_status,
        db.booking_type,
        d.name as lab_test_name,
        d.logo,
        d.open_time,
        d.close_time,
        d.location,
        db.test_status
    ');
    $this->db->from('lab_test_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'completed');

    $this->db->join('lab_tests d','d.id=db.main_data_id','left');
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $bookings = $query->result_array();

    // Append package/test/sub-test data for each booking
    foreach ($bookings as &$booking) {
        $booking_id = $booking['booking_id'];

        $this->db->select("
            p.id AS package_id, p.name AS package_name,
            p.report_in, p.fasting
        ");
        $this->db->from('lab_test_booking_packages p');
        $this->db->where('p.booking_id', $booking_id);
        $package_query = $this->db->get();
        $package_data = $package_query->result_array();

        $booking['packages'] = $package_data[0];
    }

    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id'       => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name'          => $row['lab_test_name'],
            'logo'          => $row['logo'],
            'open_time'     => $row['open_time'],
            'close_time'    => $row['close_time'],
            'location'      => $row['location'],
            'slot_id'       => intval($row['slot_id']),
            'date'          => $row['date'],
            'time'          => $row['time'],
            'booking_status'=> $row['booking_status'],
            'booking_type'  => $row['booking_type'],
            'test_status'   => $row['test_status'],
            'packages'      => $row['packages']
        ];
    }, $bookings);
}
public function get_completed_lab_test_prescription_orders($user_id){
    $this->db->select('dpb.id, dpb.booking_id, dpb.created_on,dpb.user_id,dpb.main_data_id,dpb.image,dpb.accept_status,d.name as lab_test_name,d.logo,d.open_time,d.close_time,d.location,dpb.booking_status,dpb.booking_type,dpb.test_status');
    $this->db->from('lab_test_prescription_bookings dpb');
    $this->db->where(['user_id' => $user_id,'booking_status' => 'completed']);
    $this->db->join('lab_tests d','d.id=dpb.main_data_id','left');
    $this->db->order_by('dpb.id', 'DESC');

    $query = $this->db->get();
    $orders = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['lab_test_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id'       => 0,
            'date'          => '',
            'time'          => '',
            'booking_status' => $row['booking_status'],
            'booking_type'      => $row['booking_type'],
            'test_status'      => $row['test_status'],
            'packages'      => (object)array()
        ];
    }, $orders);
}
public function lab_test_completed_combined_orders($user_id, $limit, $offset, $page){
    $product_orders = $this->get_completed_lab_test_bookings($user_id);
    $prescription_orders = $this->get_completed_lab_test_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    /*usort($combined, function($a, $b) {
        //return strtotime($b->id ?? $b['id']) - strtotime($a->created_on ?? $a['created_on']);
    });*/

    // Pagination manually
    $paged_orders = array_slice($combined, $offset, $limit);
    
    $total_pages   = ceil(count($combined) / $limit);
    $pages = [];

    for ($t = 1; $t <= $total_pages; $t++) {
        $pages[] = ['page' => $t];
    }

    return [
        'history' => $paged_orders,
        'pagination' => [
            'total_pages'  => $pages,
            'current_page' => $page,
            'limit'        => $limit
        ]
    ];
}
public function single_lab_test_booking_details($booking_id){
    // Step 1: Get main booking info
    $this->db->select('
        db.id, db.booking_id, db.user_id, db.main_data_id, db.address_id, db.slot_id, db.date, db.time,db.accept_status,db.booking_status,db.booking_type,
        db.booking_status, db.test_status, db.image, db.count, db.fee, db.consultation_fee,  db.coupon_id, db.coupon_name,
         db.coupon_percentage, db.coupon_discount, db.payment_type, db.transaction_id, hdbp.name,hdbp.fasting,db.family_member_id,db.agent_id,db.mobile,db.test_status,lt.name as lab_name,lt.logo,
    (
            (SELECT COUNT(*) FROM lab_test_booking_tests hdbt WHERE hdbt.booking_id = db.booking_id) +
            (SELECT COUNT(*) FROM lab_test_booking_subtests hdbst WHERE hdbst.booking_id = db.booking_id)
        ) AS total_test_count');
    $this->db->from('lab_test_bookings db');
    $this->db->join('lab_test_booking_packages hdbp', 'hdbp.booking_id = db.booking_id', 'left');
    $this->db->join('lab_tests lt', 'lt.id = db.main_data_id', 'left');
    //$this->db->join('lab_test_reports hdr', 'hdr.booking_id = db.booking_id and hdr.booking_type=db.booking_type', 'left');
    $this->db->where('db.booking_id', $booking_id);
    $booking = $this->db->get()->row_array();

    if (!$booking) return null;

    // Cast integers
    $booking['id'] = intval($booking['id']);
    $booking['user_id'] = intval($booking['user_id']);
    $booking['main_data_id'] = intval($booking['main_data_id']);
    $booking['address_id'] = intval($booking['address_id']);
    $booking['lab_test_id'] = intval($booking['main_data_id']);
    $booking['slot_id'] = intval($booking['slot_id']);
    $booking['count'] = intval($booking['count']);
    $booking['fee'] = intval($booking['fee']);
    $booking['consultation_fee'] = intval($booking['consultation_fee']);
    $booking['coupon_id'] = intval($booking['coupon_id']);
    $booking['coupon_percentage'] = intval($booking['coupon_percentage']);
    $booking['coupon_discount'] = intval($booking['coupon_discount']);
    $booking['total_test_count'] = intval($booking['total_test_count']);
    $booking['agent_id'] = intval($booking['agent_id']);
    $booking['mobile'] = intval($booking['mobile']);
    
    // Step 2: Get family members (if any)
    $reports = [];
    //if (!empty($booking['family_member_id'])) {
        $this->db->select('image');
        $this->db->from('lab_test_reports');
        $this->db->where(['booking_id' => $booking['booking_id'],'booking_type' => $booking['booking_type']]);
        $reports = $this->db->get()->result_array();
    //}
    $booking['reports'] = $reports;
    
    // Step 2: Get family members (if any)
    $family_members = [];
    if (!empty($booking['family_member_id'])) {
        $ids = explode(',', $booking['family_member_id']);
        $clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        if (!empty($clean_ids)) {
            $this->db->select('id, name, dob, gender, email, mobile');
            $this->db->from('family_members');
            $this->db->where_in('id', $clean_ids);
            $family_members = $this->db->get()->result_array();
            foreach ($family_members as &$member) {
                $member['id']       = intval($member['id']);
                $member['mobile']   = intval($member['mobile']);
            }
        }
    }
    $booking['family_members'] = $family_members;
    
    // Step 3: Get address (if any)
    //$family_members = [];
    if (!empty($booking['address_id'])) {
        //$ids = explode(',', $booking['family_member_id']);
        //$clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        //if (!empty($clean_ids)) {
            $this->db->select('id,hno, colony, pincode, state, landmark,address_type,default_address,lat,lon');
            $this->db->from('user_addresses');
            $this->db->where('id', $booking['address_id']);
            $address = $this->db->get()->result_array();
            $address[0]['id'] = intval($address[0]['id']);
            $address[0]['default_address'] = intval($address[0]['default_address']);
        //}
    }
    $booking['address'] = $address[0];
    
    // Step 4: Get agent (if any)
    //$family_members = [];
    /*if ($booking['agent_id']!=0) {
        //$ids = explode(',', $booking['family_member_id']);
        //$clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        //if (!empty($clean_ids)) {
            $this->db->select('id,name, image, mobile');
            $this->db->from('lab_agents');
            $this->db->where('id', $booking['agent_id']);
            $agent = $this->db->get()->result_array();
            $agent[0]['id'] = intval($agent[0]['id']);
            $agent[0]['mobile'] = intval($agent[0]['mobile']);
        //}
        $booking['agent'] = $agent[0];
    }else{
        $booking['agent'] = (object)[];
    }*/
    

    // Step 3: Join all booking-related data in one query
    $this->db->select("
        p.id AS package_id, p.name AS package_name, p.image, p.one_person, p.one_person_discount,
        p.report_in, p.fasting, p.location AS package_location,

        t.id AS test_id, t.name AS test_name,
        st.id AS sub_test_id, st.name AS sub_test_name
    ");
    $this->db->from('lab_test_booking_packages p');
    $this->db->join('lab_test_booking_tests t', 't.booking_package_id = p.id AND t.booking_id = p.booking_id', 'left');
    $this->db->join('lab_test_booking_subtests st', 'st.booking_test_id = t.id AND st.booking_id = t.booking_id', 'left');
    $this->db->where('p.booking_id', $booking_id);
    $query = $this->db->get();
    $rows = $query->result_array();

    // Step 4: Group data
    $packages = [];
    foreach ($rows as $row) {
        $pkg_id = intval($row['package_id']);
        if (!isset($packages[$pkg_id])) {
            $packages[$pkg_id] = [
                'id' => $pkg_id,
                'name' => $row['package_name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'location' => $row['package_location'],
                'tests' => []
            ];
        }

        $test_id = intval($row['test_id']);
        if ($test_id && !isset($packages[$pkg_id]['tests'][$test_id])) {
            $packages[$pkg_id]['tests'][$test_id] = [
                'id' => $test_id,
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        $sub_test_id = intval($row['sub_test_id']);
        if ($sub_test_id && isset($packages[$pkg_id]['tests'][$test_id])) {
            $packages[$pkg_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => $sub_test_id,
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Final formatting
    foreach ($packages as &$pkg) {
        $pkg['tests'] = array_values($pkg['tests']);
    }

    $booking['packages'] = array_values($packages);
    unset($booking['main_data_id'], $booking['family_member_ids']); // Clean up

    return $booking;
}
public function single_lab_test_prescription_orders($booking_id){
    // Step 1: Get main booking info
    $this->db->select('
        db.id, db.booking_id, db.user_id, db.main_data_id, db.image,db.name,db.mobile,db.accept_status,db.booking_status,db.booking_type,
        db.booking_status, db.image, d.name as lab_name,d.logo, db.family_member_id,db.address_id,
        d.open_time, d.close_time, d.location,db.test_status
    ');
    $this->db->from('lab_test_prescription_bookings db');
    $this->db->join('lab_tests d', 'd.id = db.main_data_id', 'left');
    $this->db->join('lab_test_reports hdr', 'hdr.booking_id = db.booking_id and hdr.booking_type=db.booking_type', 'left');
    $this->db->where('db.booking_id', $booking_id);
    $booking = $this->db->get()->row_array();

    if (!$booking) return null;

    // Cast integers
    $booking['id'] = intval($booking['id']);
    $booking['user_id'] = intval($booking['user_id']);
    $booking['main_data_id'] = intval($booking['main_data_id']);
    $booking['lab_test_id'] = intval($booking['main_data_id']);
    $booking['mobile'] = intval($booking['mobile']);
    $booking['address_id'] = intval($booking['address_id']);
    
    $reports = [];
    //if (!empty($booking['family_member_id'])) {
        $this->db->select('image');
        $this->db->from('lab_test_reports');
        $this->db->where(['booking_id' => $booking['booking_id'],'booking_type' => $booking['booking_type']]);
        $reports = $this->db->get()->result_array();
    //}
    $booking['reports'] = $reports;
    
    // Step 2: Get family members (if any)
    $family_members = [];
    if (!empty($booking['family_member_id'])) {
        $ids = explode(',', $booking['family_member_id']);
        $clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        if (!empty($clean_ids)) {
            $this->db->select('id, name, dob, gender, email');
            $this->db->from('family_members');
            $this->db->where_in('id', $clean_ids);
            $family_members = $this->db->get()->result_array();
            foreach ($family_members as &$member) {
                $member['id'] = intval($member['id']);
            }
        }
    }
    $booking['family_members'] = $family_members;

    unset($booking['main_data_id'], $booking['family_member_id']); // Clean up
    
    // Step 3: Get address (if any)
    //$family_members = [];
    if (!empty($booking['address_id'])) {
        //$ids = explode(',', $booking['family_member_id']);
        //$clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        //if (!empty($clean_ids)) {
            $this->db->select('id,hno, colony, pincode, state, landmark,address_type,default_address,lat,lon');
            $this->db->from('user_addresses');
            $this->db->where('id', $booking['address_id']);
            $address = $this->db->get()->result_array();
            $address[0]['id'] = intval($address[0]['id']);
            $address[0]['default_address'] = intval($address[0]['default_address']);
        //}
    }
    $booking['address'] = $address[0];
    
    // Step 4: Get agent (if any)
    //$family_members = [];
    if ($booking['agent_id']!=0) {
        //$ids = explode(',', $booking['family_member_id']);
        //$clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        //if (!empty($clean_ids)) {
            $this->db->select('id,name, image, mobile');
            $this->db->from('lab_agents');
            $this->db->where('id', $booking['agent_id']);
            $agent = $this->db->get()->result_array();
            $agent[0]['id'] = intval($agent[0]['id']);
            $agent[0]['mobile'] = intval($agent[0]['mobile']);
        //}
        $booking['agent'] = $agent[0];
    }else{
        $booking['agent'] = (object)[];
    }
    
    return $booking;
}
/*lab_tests*/

/*hospital_diagnostic_module*/
public function get_hospital_diagnostic_tests($main_data_id/*, $limit, $offset*/) {
    // Step 1: Get package IDs
    $this->db->select("id");
    $this->db->from("hospital_diagnostic_packages");
    $this->db->where("main_data_id", $main_data_id);
    $this->db->where("status", 1);
    $this->db->where("delete_status", 1);
    $this->db->order_by("id", "desc");
    //$this->db->limit($limit, $offset);
    $package_query = $this->db->get();
    $package_ids = array_column($package_query->result_array(), 'id');

    if (empty($package_ids)) {
        return []; // No packages found
    }

    // Step 2: Get all related tests and sub-tests
    $this->db->select("
        hospital_diagnostic_packages.id AS package_id,
        hospital_diagnostic_packages.name,
        hospital_diagnostic_packages.image,
        hospital_diagnostic_packages.one_person,
        hospital_diagnostic_packages.one_person_discount,
        hospital_diagnostic_packages.report_in,
        hospital_diagnostic_packages.fasting,
        hospital_diagnostic_tests.id AS test_id,
        hospital_diagnostic_tests.name AS test_name,
        hospital_diagnostic_sub_tests.id AS sub_test_id,
        hospital_diagnostic_sub_tests.name AS sub_test_name
    ");
    $this->db->from('hospital_diagnostic_packages');
    $this->db->join('hospital_diagnostic_tests', 'hospital_diagnostic_tests.package_id = hospital_diagnostic_packages.id AND hospital_diagnostic_tests.main_data_id = hospital_diagnostic_packages.main_data_id AND hospital_diagnostic_tests.status = 1 AND hospital_diagnostic_tests.delete_status = 1', 'left');
    $this->db->join('hospital_diagnostic_sub_tests', 'hospital_diagnostic_sub_tests.test_id = hospital_diagnostic_tests.id AND hospital_diagnostic_sub_tests.package_id = hospital_diagnostic_tests.package_id AND hospital_diagnostic_sub_tests.main_data_id = hospital_diagnostic_tests.main_data_id AND hospital_diagnostic_sub_tests.status = 1 AND hospital_diagnostic_sub_tests.delete_status = 1', 'left');
    $this->db->where_in('hospital_diagnostic_packages.id', $package_ids);
    $this->db->where('hospital_diagnostic_packages.main_data_id', $main_data_id);
    $this->db->where('hospital_diagnostic_packages.status', 1);
    $this->db->where('hospital_diagnostic_packages.delete_status', 1);
    $this->db->order_by('hospital_diagnostic_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Step 3: Process data
    $final_data = [];

    foreach ($result as $row) {
        $package_id = $row['package_id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($package_id),
                'name' => $row['name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'tests' => []
            ];
        }

        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        if ($sub_test_id && isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert associative test arrays to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
public function get_hospital_diagnostic_tests_rows($main_data_id){
    $this->db->from('hospital_diagnostic_packages');
    $this->db->where(['main_data_id' => $main_data_id,'status' => 1,'delete_status' => 1]);
    return $this->db->count_all_results();
}
public function get_hospital_diagnostic_dates($diagnostic_id) {
    $today = date('Y-m-d');

    $this->db->select('DISTINCT(date)', false);
    $this->db->from('hospital_diagnostic_slots');
    $this->db->where('main_data_id', $diagnostic_id);
    $this->db->where('date >=', $today);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);
    $this->db->order_by('date', 'ASC');
    
    $query = $this->db->get();
    $result = $query->result_array();

    // Format the dates
    $dates = array_map(function($row) {
        return [
            'date' => $row['date'],
            'format_date' => date('D d M', strtotime($row['date']))
        ];
    }, $result);

    return $dates;
}
public function get_hospital_diagnostic_slots($diagnostic_id,$date,$user_id) {
    $today = date('Y-m-d');
    $current_time_24hr = date('H:i');

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('hospital_diagnostic_slots');
    $this->db->where('main_data_id', $diagnostic_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // Filter only future slots if date is today
    if ($date == $today) {
        $this->db->where("STR_TO_DATE(time, '%h:%i %p') >=", $current_time_24hr);
    }

    $this->db->order_by("STR_TO_DATE(time, '%h:%i %p')", "ASC", false);

    $query = $this->db->get();
    $raw_slots = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    $added_times = []; // To avoid duplicates

    foreach ($raw_slots as $row) {
        $time_24hr = date('H:i', strtotime($row['time']));
        if (in_array($row['time'], $added_times)) continue; // prevent duplicates
        $added_times[] = $row['time'];

        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        if ($time_24hr >= 0 && $time_24hr < 12) {
            $slots['morning'][] = $row;
        } elseif ($time_24hr >= 12 && $time_24hr < 17) {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    // Get family members
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    foreach ($family_members as &$member) {
        $member['id'] = (int) $member['id'];
    }

    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
public function get_single_hospital_diagnostic_tests($test_id){
    // Step 1: Get package IDs
    $this->db->select("id");
    $this->db->from("hospital_diagnostic_packages");
    $this->db->where("id", $test_id);
    /*$this->db->where("status", 1);
    $this->db->where("delete_status", 1);*/
    $this->db->order_by("id", "desc");
    $this->db->limit($limit, $offset);
    $package_query = $this->db->get();
    $package_ids = array_column($package_query->result_array(), 'id');

    if (empty($package_ids)) {
        return []; // No packages found
    }

    // Step 2: Get all related tests and sub-tests
    $this->db->select("
        hospital_diagnostic_packages.id AS package_id,
        hospital_diagnostic_packages.name,
        hospital_diagnostic_packages.image,
        hospital_diagnostic_packages.one_person,
        hospital_diagnostic_packages.one_person_discount,
        hospital_diagnostic_packages.report_in,
        hospital_diagnostic_packages.fasting,
        hospital_diagnostic_tests.id AS test_id,
        hospital_diagnostic_tests.name AS test_name,
        hospital_diagnostic_sub_tests.id AS sub_test_id,
        hospital_diagnostic_sub_tests.name AS sub_test_name,
        main_data.location
    ");
    $this->db->from('hospital_diagnostic_packages');
    $this->db->join('hospital_diagnostic_tests', 'hospital_diagnostic_tests.package_id = hospital_diagnostic_packages.id AND hospital_diagnostic_tests.main_data_id = hospital_diagnostic_packages.main_data_id AND hospital_diagnostic_tests.status = 1 AND hospital_diagnostic_tests.delete_status = 1', 'left');
    $this->db->join('hospital_diagnostic_sub_tests', 'hospital_diagnostic_sub_tests.test_id = hospital_diagnostic_tests.id AND hospital_diagnostic_sub_tests.package_id = hospital_diagnostic_tests.package_id AND hospital_diagnostic_sub_tests.main_data_id = hospital_diagnostic_tests.main_data_id AND hospital_diagnostic_sub_tests.status = 1 AND hospital_diagnostic_sub_tests.delete_status = 1', 'left');
    $this->db->join('main_data','main_data.id=hospital_diagnostic_packages.main_data_id','left');
    $this->db->where_in('hospital_diagnostic_packages.id', $package_ids);
    $this->db->where('hospital_diagnostic_packages.id', $test_id);
    $this->db->where('hospital_diagnostic_packages.status', 1);
    $this->db->where('hospital_diagnostic_packages.delete_status', 1);
    $this->db->order_by('hospital_diagnostic_packages.id', 'desc');

    $query = $this->db->get();
    $result = $query->result_array();

    // Step 3: Process data
    $final_data = [];

    foreach ($result as $row) {
        $package_id = $row['package_id'];
        $test_id = $row['test_id'];
        $sub_test_id = $row['sub_test_id'];

        if (!isset($final_data[$package_id])) {
            $final_data[$package_id] = [
                'id' => intval($package_id),
                'name' => $row['name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'location' => $row['location'],
                'tests' => []
            ];
        }

        if ($test_id && !isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id] = [
                'id' => intval($test_id),
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        if ($sub_test_id && isset($final_data[$package_id]['tests'][$test_id])) {
            $final_data[$package_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => intval($sub_test_id),
                'name' => $row['sub_test_name']
            ];
        }
    }

    // Convert associative test arrays to indexed
    foreach ($final_data as &$package) {
        $package['tests'] = array_values($package['tests']);
    }

    return array_values($final_data);
}
public function save_hospital_diagnostic_booking_snapshot($booking_id, $diagnostic_data) {
    foreach ($diagnostic_data as $package) {
        // 1. Insert into booking_diagnostic_packages
        $package_data = [
            'booking_id' => $booking_id,
            'name' => $package['name'],
            'image' => $package['image'],
            'one_person' => $package['one_person'],
            'one_person_discount' => $package['one_person_discount'],
            'report_in' => $package['report_in'],
            'fasting' => $package['fasting'],
            'location' => $package['location'],
            'created_on'    => date('Y-m-d H:i:s')
        ];
        $this->db->insert('hospital_diagnostic_booking_packages', $package_data);
        $booking_package_id = $this->db->insert_id();

        foreach ($package['tests'] as $test) {
            // 2. Insert into booking_diagnostic_tests
            $test_data = [
                'booking_id' => $booking_id,
                'booking_package_id' => $booking_package_id,
                'name' => $test['name'],
                'created_on'    => date('Y-m-d H:i:s')
            ];
            $this->db->insert('hospital_diagnostic_booking_tests', $test_data);
            $booking_test_id = $this->db->insert_id();

            foreach ($test['sub_tests'] as $sub_test) {
                // 3. Insert into booking_diagnostic_subtests
                $subtest_data = [
                    'booking_id' => $booking_id,
                    'booking_test_id' => $booking_test_id,
                    'name' => $sub_test['name'],
                    'created_on'    => date('Y-m-d H:i:s')
                ];
                $this->db->insert('hospital_diagnostic_booking_subtests', $subtest_data);
            }
        }
    }
}
public function get_hospital_diagnostic_bookings($user_id) {
    $this->db->select('db.id, db.booking_id, db.created_on, db.user_id, db.main_data_id, db.slot_id,db.date,db.time,db.booking_status, db.booking_type, d.name as diagnostic_name, d.logo, d.open_time, d.close_time, d.location');
    $this->db->from('hospital_diagnostic_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'booked');

    // Accept status condition
    $this->db->group_start();
    $this->db->where('db.accept_status', 'accepted');
    $this->db->or_where('db.accept_status', '');
    $this->db->group_end();

    $this->db->join('main_data d', 'd.id = db.main_data_id', 'left');
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $bookings = $query->result_array();

    // Attach package/test/subtest details
    foreach ($bookings as &$booking) {
        $booking_id = $booking['booking_id'];

        $this->db->reset_query();

        $this->db->select("p.id AS package_id, p.name AS package_name, p.report_in, p.fasting");
        $this->db->from('hospital_diagnostic_booking_packages p');
        $this->db->where('p.booking_id', $booking_id);

        $query2 = $this->db->get();
        $rows = $query2->result_array();

        $packages = [];
        foreach ($rows as $row) {
            $pkg_id = $row['package_id'];
            if (!isset($packages[$pkg_id])) {
                $packages[$pkg_id] = [
                    'package_id' => $row['package_id'],
                    'package_name' => $row['package_name'],
                    'report_in' => $row['report_in'],
                    'fasting' => $row['fasting']
                ];
            }

            // You can add logic here to fetch test/subtest if needed in the future
        }

        $booking['packages'] = array_values($packages);
    }

    // Final formatting
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => intval($row['slot_id']),
            'date' => $row['date'],
            'time' => $row['time'],
            'booking_status' => $row['booking_status'],
            'booking_type' => $row['booking_type'],
            'packages' => isset($row['packages']) ? $row['packages'][0] : (object)[]
        ];
    }, $bookings);
}
public function get_hospital_diagnostic_prescription_orders($user_id){
    $this->db->select('dpb.id, dpb.booking_id, dpb.created_on,dpb.user_id,dpb.main_data_id,dpb.image,dpb.accept_status,d.name as diagnostic_name,d.logo,d.open_time,d.close_time,d.location,dpb.booking_status,dpb.booking_type,');
    $this->db->from('hospital_diagnostic_prescription_bookings dpb');
    $this->db->where(['user_id' => $user_id,'booking_status' => 'booked']);
    // Add accept_status = 'accepted' OR accept_status = ''
    $this->db->group_start();
    $this->db->where('accept_status', 'accepted');
    $this->db->or_where('accept_status', '');
    $this->db->group_end();
    $this->db->join('main_data d','d.id=dpb.main_data_id','left');
    $this->db->order_by('dpb.id', 'DESC');

    $query = $this->db->get();
    $orders = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => 0,
            'date' => '',
            'time' => '',
            'booking_status' => $row['booking_status'],
            'booking_type'      => $row['booking_type'],
            'packages' => (object)[]
        ];
    }, $orders);
}
public function hospital_diagnostic_combined_orders($user_id, $limit, $offset,$page){
    $product_orders = $this->get_hospital_diagnostic_bookings($user_id);
    $prescription_orders = $this->get_hospital_diagnostic_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    if(!empty($combined)){
        /*usort($combined, function($a, $b) {
            //return strtotime($b->id ?? $b['id']) - strtotime($a->created_on ?? $a['created_on']);
        });*/
    
        // Pagination manually
        $paged_orders = array_slice($combined, $offset, $limit);
    
        $total_pages   = ceil(count($combined) / $limit);
        $pages = [];
    
        for ($t = 1; $t <= $total_pages; $t++) {
            $pages[] = ['page' => $t];
        }
    
        return [
            'history' => $paged_orders,
            'pagination' => [
                'total_pages'  => $pages,
                'current_page' => $page,
                'limit'        => $limit
            ]
        ];
    }else{
        return [];
    }
}
public function get_hospital_completed_diagnostic_bookings($user_id) {
    $this->db->select('db.id, db.booking_id, db.created_on, db.user_id, db.main_data_id, db.slot_id,db.date,db.time,db.booking_status, db.booking_type, d.name as diagnostic_name, d.logo, d.open_time, d.close_time, d.location');
    $this->db->from('hospital_diagnostic_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'completed');

    $this->db->join('main_data d', 'd.id = db.main_data_id', 'left');
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $bookings = $query->result_array();

    foreach ($bookings as &$booking) {
        $booking_id = $booking['booking_id'];

        $this->db->reset_query();
        $this->db->select("p.id AS package_id, p.name AS package_name, p.report_in, p.fasting");
        $this->db->from('hospital_diagnostic_booking_packages p');
        $this->db->where('p.booking_id', $booking_id);

        $query2 = $this->db->get();
        $rows = $query2->result_array();

        $packages = [];
        foreach ($rows as $row) {
            $pkg_id = $row['package_id'];
            if (!isset($packages[$pkg_id])) {
                $packages[$pkg_id] = [
                    'package_id' => $row['package_id'],
                    'package_name' => $row['package_name'],
                    'report_in' => $row['report_in'],
                    'fasting' => $row['fasting']
                ];
            }
        }

        $booking['packages'] = array_values($packages);
    }

    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => intval($row['slot_id']),
            'date' => $row['date'],
            'time' => $row['time'],
            'booking_status' => $row['booking_status'],
            'booking_type' => $row['booking_type'],
            'packages' => isset($row['packages']) ? $row['packages'][0] : (object)[]
        ];
    }, $bookings);
}
public function get_hospital_completed_diagnostic_prescription_orders($user_id){
    $this->db->select('dpb.id, dpb.booking_id, dpb.created_on,dpb.user_id,dpb.main_data_id,dpb.image,dpb.accept_status,d.name as diagnostic_name,d.logo,d.open_time,d.close_time,d.location,dpb.booking_status,dpb.booking_type,');
    $this->db->from('hospital_diagnostic_prescription_bookings dpb');
    $this->db->where(['user_id' => $user_id,'booking_status' => 'completed']);
    $this->db->join('main_data d','d.id=dpb.main_data_id','left');
    $this->db->order_by('dpb.id', 'DESC');

    $query = $this->db->get();
    $orders = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'diagnostic_id' => intval($row['main_data_id']),
            'name' => $row['diagnostic_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'slot_id' => 0,
            'date' => '',
            'time' => '',
            'booking_status' => $row['booking_status'],
            'booking_type'      => $row['booking_type'],
            'packages' => (object)[]
        ];
    }, $orders);
}
public function hospital_diagnostic_completed_combined_orders($user_id, $limit, $offset, $page){
    $product_orders = $this->get_hospital_completed_diagnostic_bookings($user_id);
    $prescription_orders = $this->get_hospital_completed_diagnostic_prescription_orders($user_id);

    // Merge and sort by created_on
    $combined = array_merge($product_orders, $prescription_orders);

    /*usort($combined, function($a, $b) {
        //return strtotime($b->id ?? $b['id']) - strtotime($a->created_on ?? $a['created_on']);
    });*/

    // Pagination manually
    $paged_orders = array_slice($combined, $offset, $limit);
    
    $total_pages   = ceil(count($combined) / $limit);
    $pages = [];

    for ($t = 1; $t <= $total_pages; $t++) {
        $pages[] = ['page' => $t];
    }

    return [
        'history' => $paged_orders,
        'pagination' => [
            'total_pages'  => $pages,
            'current_page' => $page,
            'limit'        => $limit
        ]
    ];
}
public function single_hospital_diagnostic_booking_details($booking_id) {
    // Step 1: Get main booking info
    $this->db->select('
        db.id, db.booking_id, db.user_id, db.main_data_id, db.slot_id, db.date, db.time,
        db.accept_status, db.booking_status, db.booking_type,
        db.test_status, db.image, db.count, db.fee, db.consultation_fee,
        db.coupon_id, db.coupon_name, db.coupon_percentage, db.coupon_discount,
        db.payment_type, db.transaction_id, d.name as diagnostic_name,
        d.logo, db.family_member_id, d.open_time, d.close_time, d.location, d.lat, d.lon
    ');
    $this->db->from('hospital_diagnostic_bookings db');
    $this->db->join('main_data d', 'd.id = db.main_data_id', 'left');
    $this->db->where('db.booking_id', $booking_id);
    $booking = $this->db->get()->row_array();

    if (!$booking) return null;

    // Cast integers
    $booking['id'] = intval($booking['id']);
    $booking['user_id'] = intval($booking['user_id']);
    $booking['main_data_id'] = intval($booking['main_data_id']);
    $booking['diagnostic_id'] = intval($booking['main_data_id']);
    $booking['slot_id'] = intval($booking['slot_id']);
    $booking['count'] = intval($booking['count']);
    $booking['fee'] = intval($booking['fee']);
    $booking['consultation_fee'] = intval($booking['consultation_fee']);
    $booking['coupon_id'] = intval($booking['coupon_id']);
    $booking['coupon_percentage'] = intval($booking['coupon_percentage']);
    $booking['coupon_discount'] = intval($booking['coupon_discount']);

    // Step 2: Diagnostic reports
    $this->db->select('image');
    $this->db->from('hospital_diagnostic_reports');
    $this->db->where(['booking_id' => $booking['booking_id'], 'booking_type' => $booking['booking_type']]);
    $booking['reports'] = $this->db->get()->result_array();

    // Step 3: Family members
    $family_members = [];
    if (!empty($booking['family_member_id'])) {
        $ids = explode(',', $booking['family_member_id']);
        $clean_ids = array_map('intval', array_filter($ids));
        if (!empty($clean_ids)) {
            $this->db->select('id, name, dob, gender, email, mobile');
            $this->db->from('family_members');
            $this->db->where_in('id', $clean_ids);
            $family_members = $this->db->get()->result_array();
            foreach ($family_members as &$member) {
                $member['id'] = intval($member['id']);
                $member['mobile'] = intval($member['mobile']);
            }
        }
    }
    $booking['family_members'] = $family_members;

    // Step 4: Package, test, and subtest structure
    $this->db->select("
        p.id AS package_id, p.name AS package_name, p.image, p.one_person, p.one_person_discount,
        p.report_in, p.fasting, p.location AS package_location,
        t.id AS test_id, t.name AS test_name,
        st.id AS sub_test_id, st.name AS sub_test_name
    ");
    $this->db->from('hospital_diagnostic_booking_packages p');
    $this->db->join('hospital_diagnostic_booking_tests t', 't.booking_package_id = p.id AND t.booking_id = p.booking_id', 'left');
    $this->db->join('hospital_diagnostic_booking_subtests st', 'st.booking_test_id = t.id AND st.booking_id = t.booking_id', 'left');
    $this->db->where('p.booking_id', $booking_id);
    $rows = $this->db->get()->result_array();

    $packages = [];
    foreach ($rows as $row) {
        $pkg_id = intval($row['package_id']);
        if (!isset($packages[$pkg_id])) {
            $packages[$pkg_id] = [
                'id' => $pkg_id,
                'name' => $row['package_name'],
                'image' => $row['image'],
                'one_person' => intval($row['one_person']),
                'one_person_discount' => intval($row['one_person_discount']),
                'report_in' => $row['report_in'],
                'fasting' => $row['fasting'],
                'location' => $row['package_location'],
                'tests' => []
            ];
        }

        $test_id = intval($row['test_id']);
        if ($test_id && !isset($packages[$pkg_id]['tests'][$test_id])) {
            $packages[$pkg_id]['tests'][$test_id] = [
                'id' => $test_id,
                'name' => $row['test_name'],
                'sub_tests' => []
            ];
        }

        $sub_test_id = intval($row['sub_test_id']);
        if ($sub_test_id && isset($packages[$pkg_id]['tests'][$test_id])) {
            $packages[$pkg_id]['tests'][$test_id]['sub_tests'][] = [
                'id' => $sub_test_id,
                'name' => $row['sub_test_name']
            ];
        }
    }

    foreach ($packages as &$pkg) {
        $pkg['tests'] = array_values($pkg['tests']);
    }

    $booking['packages'] = array_values($packages);

    // Step 5: Get flat list of package test names
    $this->db->select('name');
    $this->db->from('hospital_diagnostic_booking_packages');
    $this->db->where('booking_id', $booking_id);
    $this->db->group_by('name');
    $package_names = $this->db->get()->result_array();
    
    // Convert to comma-separated string
    $booking['package_test_name'] = implode(', ', array_column($package_names, 'name'));


    unset($booking['main_data_id'], $booking['family_member_ids']); // Cleanup

    return $booking;
}
public function single_hospital_diagnostic_prescription_orders($booking_id){
    // Step 1: Get main booking info
    $this->db->select('
        db.id, db.booking_id, db.user_id, db.main_data_id, db.image,db.name,db.mobile,db.accept_status,db.booking_status,db.booking_type,
        db.booking_status, db.image, d.name as diagnostic_name,d.logo, db.family_member_id,
        d.open_time, d.close_time, d.location
    ');
    $this->db->from('hospital_diagnostic_prescription_bookings db');
    $this->db->join('main_data d', 'd.id = db.main_data_id', 'left');
    $this->db->where('db.booking_id', $booking_id);
    $booking = $this->db->get()->row_array();

    if (!$booking) return null;

    // Cast integers
    $booking['id'] = intval($booking['id']);
    $booking['user_id'] = intval($booking['user_id']);
    $booking['main_data_id'] = intval($booking['main_data_id']);
    $booking['diagnostic_id'] = intval($booking['main_data_id']);
    $booking['mobile'] = intval($booking['mobile']);
    
    $reports = [];
    //if (!empty($booking['family_member_id'])) {
        $this->db->select('image');
        $this->db->from('hospital_diagnostic_reports');
        $this->db->where(['booking_id' => $booking['booking_id'],'booking_type' => $booking['booking_type']]);
        $reports = $this->db->get()->result_array();
    //}
    $booking['reports'] = $reports;
    
    // Step 2: Get family members (if any)
    $family_members = [];
    if (!empty($booking['family_member_id'])) {
        $ids = explode(',', $booking['family_member_id']);
        $clean_ids = array_map('intval', array_filter($ids)); // Clean empty/null
        if (!empty($clean_ids)) {
            $this->db->select('id, name, dob, gender, email');
            $this->db->from('family_members');
            $this->db->where_in('id', $clean_ids);
            $family_members = $this->db->get()->result_array();
            foreach ($family_members as &$member) {
                $member['id'] = intval($member['id']);
            }
        }
    }
    $booking['family_members'] = $family_members;

    unset($booking['main_data_id'], $booking['family_member_id']); // Clean up

    return $booking;
}
/*hospital_diagnostic_module*/

/*main data*/
public function get_main_data_first($cat_id, $lat, $lon, $radius,$limit,$offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.open_time,main_data.close_time,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'cat_id' => intval($row['cat_id']),
            'sub_cat_id' => intval($row['sub_cat_id']),
            'sub_sub_cat_id' => intval($row['sub_sub_cat_id']),
            'name' => $row['name'],
            'tagline' => $row['tagline'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'lat' => $row['lat'],
            'lon' => $row['lon'],
        ];
    }, $result);
}
public function get_main_data_first_rows($cat_id, $lat, $lon, $radius) {
    $this->db->select("COUNT(*) as total_rows", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance calculation should be in WHERE, not HAVING
    $this->db->where("COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) <= ", $radius);

    // Execute the query
    $query = $this->db->get();
    
    // Get the count of records
    if ($query->num_rows() > 0) {
        $result = $query->row()->total_rows;
    } else {
        $result = 0;
    }

    return $result;
}
public function get_search_main_data_first($cat_id, $lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.open_time,main_data.close_time,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'cat_id' => intval($row['cat_id']),
            'sub_cat_id' => intval($row['sub_cat_id']),
            'sub_sub_cat_id' => intval($row['sub_sub_cat_id']),
            'name' => $row['name'],
            'tagline' => $row['tagline'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'lat' => $row['lat'],
            'lon' => $row['lon'],
        ];
    }, $result);

}
public function filter_data($cat_id,$sub_cat_ids,$sub_sub_cat_ids,$radius,$lat,$lon,$limit, $offset){
    // Fetch data from `main_data`
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.open_time,main_data.close_time,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where_in('main_data.sub_cat_id', $sub_cat_ids);

    // Apply `sub_sub_cat_id` filter if provided
    if (!empty($sub_sub_cat_ids)) {
        $this->db->where_in('main_data.sub_sub_cat_id', $sub_sub_cat_ids);
    }
    
    // Distance Filter
    $this->db->having('distance <=', $radius);
    
    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'cat_id' => intval($row['cat_id']),
            'sub_cat_id' => intval($row['sub_cat_id']),
            'sub_sub_cat_id' => intval($row['sub_sub_cat_id']),
            'name' => $row['name'],
            'tagline' => $row['tagline'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'lat' => $row['lat'],
            'lon' => $row['lon'],
        ];
    }, $result);
}
public function get_filter_data_rows($cat_id,$sub_cat_ids,$sub_sub_cat_ids,$radius,$lat,$lon){
    // Fetch data from `main_data`
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    $this->db->where('main_data.cat_id', $cat_id);
    $this->db->where_in('main_data.sub_cat_id', $sub_cat_ids);

    // Apply `sub_sub_cat_id` filter if provided
    if (!empty($sub_sub_cat_ids)) {
        $this->db->where_in('main_data.sub_sub_cat_id', $sub_sub_cat_ids);
    }
    
    // Distance Filter
    $this->db->having('distance <=', $radius);
    
    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $query = $this->db->get();
    $result = $query->num_rows();
    return $result;
}
public function get_sub_cat_main_data_first($sub_cat_id, $lat, $lon, $radius,$limit,$offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.open_time,main_data.close_time,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.sub_cat_id', $sub_cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'cat_id' => intval($row['cat_id']),
            'sub_cat_id' => intval($row['sub_cat_id']),
            'sub_sub_cat_id' => intval($row['sub_sub_cat_id']),
            'name' => $row['name'],
            'tagline' => $row['tagline'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'lat' => $row['lat'],
            'lon' => $row['lon'],
        ];
    }, $result);
}
public function get_sub_cat_main_data_first_rows($sub_cat_id, $lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.sub_cat_id', $sub_cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    
    return $result;
}
public function get_search_sub_cat_main_data_first($sub_cat_id, $lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.open_time,main_data.close_time,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.sub_cat_id', $sub_cat_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'cat_id' => intval($row['cat_id']),
            'sub_cat_id' => intval($row['sub_cat_id']),
            'sub_sub_cat_id' => intval($row['sub_sub_cat_id']),
            'name' => $row['name'],
            'tagline' => $row['tagline'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'lat' => $row['lat'],
            'lon' => $row['lon'],
        ];
    }, $result);

}
public function get_all_hospitals_first($lat, $lon, $radius, $limit, $offset){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.open_time,main_data.close_time,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    $this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'cat_id' => intval($row['cat_id']),
            'sub_cat_id' => intval($row['sub_cat_id']),
            'sub_sub_cat_id' => intval($row['sub_sub_cat_id']),
            'name' => $row['name'],
            'tagline' => $row['tagline'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'lat' => $row['lat'],
            'lon' => $row['lon'],
        ];
    }, $result);
}
public function get_all_hospitals_first_rows($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');
    //$this->db->limit($limit,$offset);
    $query = $this->db->get();
    $result = $query->num_rows();

    return $result;
}
public function get_search_all_hospitals_first($lat, $lon, $search, $radius) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.sub_cat_id,main_data.sub_sub_cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.open_time,main_data.close_time,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    
    // Filters
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'cat_id' => intval($row['cat_id']),
            'sub_cat_id' => intval($row['sub_cat_id']),
            'sub_sub_cat_id' => intval($row['sub_sub_cat_id']),
            'name' => $row['name'],
            'tagline' => $row['tagline'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'lat' => $row['lat'],
            'lon' => $row['lon'],
        ];
    }, $result);
}
public function get_main_data(/*$cat_id, */$lat, $lon, $radius, $main_data_id) {
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.*, categories.name as tagline,
        GROUP_CONCAT(DISTINCT img.image) AS images,
        GROUP_CONCAT(DISTINCT CONCAT(specialities.id, '|', specialities.name, '|', specialities.image)) AS specialities
    ", false); 
    
    $this->db->from('main_data');

    // Join images table
    $this->db->join('images img', 'img.cat_id = main_data.cat_id AND img.main_data_id = main_data.id AND img.status=1 AND img.delete_status=1', 'left');

    // Join specialities
    $this->db->join('main_data_specialities', 'main_data_specialities.main_data_id = main_data.id AND main_data_specialities.status=1 AND main_data_specialities.delete_status=1', 'left');
    $this->db->join('specialities', 'specialities.id = main_data_specialities.speciality_id', 'left');
    $this->db->join('categories', 'categories.id = main_data.cat_id', 'left');

    // Filters
    //$this->db->where('main_data.cat_id', $cat_id);
    $this->db->where('main_data.id', $main_data_id);
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping & Sorting
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        // Fetch pharmacy categories if pharmacy is yes
        // Fetch pharmacy categories if pharmacy is yes
        $pharmacy_categories = [];
        if (strtolower($row['pharmacy']) === 'yes') {
            $CI =& get_instance();
            $CI->db->select('id, name, image');
            $CI->db->from('pharmacy_categories');
            $CI->db->where('status', 1);
            $CI->db->where('delete_status', 1);
            $pharmacy_categories = array_map(function ($item) {
                return [
                    'id'    => intval($item['id']),
                    'name'  => $item['name'],
                    'image' => $item['image']
                ];
            }, $CI->db->get()->result_array());
        }


        // Diagnostic array is empty for now if diagnostic = 'yes'
        $diagnostic_categories = (strtolower($row['diagnostic']) === 'yes') ? [] : null;

        return [
            'id'          => intval($row['id']),
            'name'        => $row['name'],
            'mobile'      => intval($row['mobile']),
            'tagline'     => $row['tagline'],
            'logo'        => $row['logo'],
            'open_time'   => $row['open_time'],
            'close_time'  => $row['close_time'],
            'location'    => $row['location'],
            'description' => $row['description'],
            'cat_id'      => intval($row['cat_id']),
            'sub_cat_id'      => intval($row['sub_cat_id']),
            'sub_sub_cat_id'  => intval($row['sub_sub_cat_id']),
            'lat'           => $row['lat'],
            'lon'           => $row['lon'],
            'pharmacy'      => $row['pharmacy'],
            'diagnostic'    => $row['diagnostic'],
            'home_delivery' => $row['home_delivery'],
            'images'      => (!empty($row['images']) && is_string($row['images']))
                ? array_map(function ($image) {
                    return ['url' => trim($image)];
                }, array_filter(explode(',', $row['images'])))
                : [],
            'specialities' => (!empty($row['specialities']) && is_string($row['specialities']))
                ? array_map(function ($speciality) {
                    list($id, $name, $image) = explode('|', $speciality);
                    return [
                        'id'    => intval($id),
                        'name'  => $name,
                        'image' => $image
                    ];
                }, array_filter(explode(',', $row['specialities'])))
                : [],
            //'pharmacy_categories'   => $pharmacy_categories,
            //'diagnostic_categories' => $diagnostic_categories,
        ];
    }, $result);
}
/*main data*/

/*hospital_doctor_module*/
public function get_doctors(/*$cat_id, */$main_data_id, $speciality_id, $limit, $offset) {
    $this->db->select('
        doctors.*, 
        IFNULL(rating_data.total_rating, 0) AS total_rating, 
        IFNULL(rating_data.total_reviews, 0) AS total_reviews,
        main_data.name as hospital_name,
        main_data.location, 
        GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification, 
        s.name as specialization,
        IFNULL(consultation_data.consultations, 0) AS consultations
    ');
    
    $this->db->from('doctors');

    // Where conditions
    $this->db->where([
        //'doctors.cat_id' => $cat_id,
        'doctors.main_data_id' => $main_data_id,
        'doctors.speciality_id' => $speciality_id,
        'doctors.availability' => 1,
        'doctors.status' => 1,
        'doctors.delete_status' => 1
    ]);

    // Correct joins
    $this->db->join('main_data', 'main_data.id = doctors.main_data_id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, doctors.qualification)', 'left');
    $this->db->join('specialities s', 's.id = doctors.speciality_id', 'left');

    // Subquery join for ratings
    $this->db->join(
        '(SELECT doctor_id, cat_id, main_data_id, SUM(rating) as total_rating, COUNT(id) as total_reviews 
          FROM doctor_ratings 
          GROUP BY doctor_id, cat_id, main_data_id) rating_data',
        'rating_data.cat_id = doctors.cat_id 
         AND rating_data.main_data_id = doctors.main_data_id 
         AND rating_data.doctor_id = doctors.id',
        'left'
    );

    // Subquery join for consultations
    $this->db->join(
        '(SELECT doctor_id, COUNT(id) as consultations 
          FROM doctor_bookings 
          GROUP BY doctor_id) consultation_data',
        'consultation_data.doctor_id = doctors.id',
        'left'
    );

    $this->db->group_by('doctors.id');
    $this->db->order_by('doctors.id', 'desc');
    $this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array(); 

    // Process the results
    return array_map(function ($row) {
        $total_rating = floatval($row['total_rating']);
        $total_reviews = intval($row['total_reviews']);
        $average_rating = ($total_reviews > 0) ? round($total_rating / $total_reviews, 1) : 0.0;

        return [
            'id'                => intval($row['id']),
            'unique_id'         => $row['unique_id'],
            'cat_id'            => intval($row['cat_id']),
            'sub_cat_id'        => intval($row['sub_cat_id']),
            'sub_sub_cat_id'    => intval($row['sub_sub_cat_id']),
            'main_data_id'      => intval($row['main_data_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'name'              => $row['name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'hospital_name'     => $row['hospital_name'],
            'exp'               => intval($row['exp']),
            'description'       => $row['description'],
            'consult_type'      => $row['consult_type'],
            'offline_fee'       => intval($row['offline_fee']),
            'online_fee'        => intval($row['online_fee']),
            //'consult_type'      => $row['consult_type'],
            'rating'            => $average_rating,
            'total_reviews'     => $total_reviews,
            'consultations'     => intval($row['consultations']),
            'location'          => $row['location']
        ];
    }, $result);
}
public function get_doctors_rows(/*$cat_id, */$main_data_id, $speciality_id) {
    $this->db->from('doctors');
    $this->db->where([
        //'doctors.cat_id' => $cat_id,
        'doctors.main_data_id' => $main_data_id,
        'doctors.speciality_id' => $speciality_id,
        'doctors.availability' => 1,
        'doctors.status' => 1,
        'doctors.delete_status' => 1
    ]);
    return $this->db->count_all_results();
}
public function get_doctor_dates(/*$cat_id,*/$main_data_id,$speciality_id,$doctor_id) {
    $today = date('Y-m-d');

    $this->db->select('DISTINCT(date)', false);
    $this->db->from('doctor_slots');
    //$this->db->where('cat_id', $cat_id);
    $this->db->where('main_data_id', $main_data_id);
    $this->db->where('speciality_id', $speciality_id);
    $this->db->where('doctor_id', $doctor_id);
    $this->db->where('date >=', $today);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);
    $this->db->order_by('date', 'ASC');
    
    $query = $this->db->get();
    $result = $query->result_array();

    // Format the dates
    $dates = array_map(function($row) {
        return [
            'date' => $row['date'],
            'format_date' => date('D d M', strtotime($row['date']))
        ];
    }, $result);

    return $dates;
}
public function get_doctor_slots($main_data_id, $speciality_id, $doctor_id, $date, $user_id) {
    $today = date('Y-m-d');
    $current_time_24hr = date('H:i');

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('doctor_slots');
    $this->db->where('main_data_id', $main_data_id);
    $this->db->where('speciality_id', $speciality_id);
    $this->db->where('doctor_id', $doctor_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // Filter only future slots if date is today
    if ($date == $today) {
        $this->db->where("STR_TO_DATE(time, '%h:%i %p') >=", $current_time_24hr);
    }

    $this->db->order_by("STR_TO_DATE(time, '%h:%i %p')", "ASC", false);

    $query = $this->db->get();
    $raw_slots = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    $added_times = []; // To avoid duplicates

    foreach ($raw_slots as $row) {
        $time_24hr = date('H:i', strtotime($row['time']));
        if (in_array($row['time'], $added_times)) continue; // prevent duplicates
        $added_times[] = $row['time'];

        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        if ($time_24hr >= 0 && $time_24hr < 12) {
            $slots['morning'][] = $row;
        } elseif ($time_24hr >= 12 && $time_24hr < 17) {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }

    // Fetch family members
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    foreach ($family_members as &$member) {
        $member['id'] = intval($member['id']);
    }

    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
public function doctor_bookings_history_active($user_id, $limit, $offset) {
    $this->db->select(' b.id,  b.booking_id,b.consult_type,b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, s.name AS specialization, d.name AS doctor_name, d.unique_id, d.image, d.specialization,d.exp, GROUP_CONCAT(md.name ORDER BY md.name SEPARATOR ", ") AS qualification, fm.email, fm.gender, fm.dob, (SELECT COUNT(*) FROM online_doctor_bookings WHERE doctor_id = b.doctor_id) AS consultations,odc.name as specialization ');

    $this->db->from('doctor_bookings b');
    $this->db->join('specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    $this->db->join('specialities odc', 'odc.id = d.speciality_id', 'left');
    // Filtering
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'booked');
    
    // Grouping to avoid duplicates due to multiple degrees
    $this->db->group_by('b.id');
    
    // Pagination & Sorting
    $this->db->limit($limit, $offset);
    $this->db->order_by('b.id', 'desc');
    
    $query = $this->db->get();
    $result = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'cat_id'            => intval($row['cat_id']),
            'main_data_id'      => intval($row['main_data_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => $row['date'],
            'mobile'            => intval($row['mobile']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'specialization'    => $row['specialization'],
            'unique_id'         => $row['unique_id'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => $row['exp'],
            'consultations'     => intval($row['consultations']),
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
        ];
    }, $result);

}
public function doctor_bookings_history_active_rows($user_id) {
    $this->db->from('doctor_bookings b');
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'booked');
    return $this->db->count_all_results();
}
public function doctor_bookings_history_completed($user_id, $limit, $offset) {
    $this->db->select('b.id, b.booking_id,b.consult_type,b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.patient_name, s.name AS specialization, d.name AS doctor_name, d.unique_id, d.image, d.exp, d.specialization, GROUP_CONCAT(md.name ORDER BY md.name SEPARATOR ", ") AS qualification, fm.email, fm.gender, fm.dob, (SELECT COUNT(*) FROM online_doctor_bookings WHERE doctor_id = b.doctor_id) AS consultations,odc.name as specialization ');

    $this->db->from('doctor_bookings b');
    $this->db->join('specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    $this->db->join('specialities odc', 'odc.id = d.speciality_id', 'left');
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    
    $this->db->group_by('b.id');
    $this->db->limit($limit, $offset);
    $this->db->order_by('b.id', 'desc');
    
    $query = $this->db->get();
    $result = $query->result_array();
    
    return array_map(function ($row) {
        return [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'cat_id'            => intval($row['cat_id']),
            'main_data_id'      => intval($row['main_data_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => $row['date'],
            'mobile'            => intval($row['mobile']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            //'speciality_name'   => $row['speciality_name'],
            'unique_id'         => $row['unique_id'],
            'name'              => $row['doctor_name'],
            'image'             => $row['image'],
            'qualification'     => $row['qualification'],
            'specialization'    => $row['specialization'],
            'exp'               => $row['exp'],
            'consultations'     => intval($row['consultations']),
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
        ];
    }, $result);

}
public function doctor_bookings_history_completed_rows($user_id) {
    $this->db->from('doctor_bookings b');
    $this->db->where('b.user_id', $user_id);
    $this->db->where('b.booking_status', 'completed');
    return $this->db->count_all_results();
}
public function doctor_single_booking_history_completed($booking_id) {
    $this->db->select('b.id, b.booking_id, b.consult_type, b.user_id, b.speciality_id, b.doctor_id, b.slot_id, b.time, b.date, b.mobile, b.call_status, b.family_member_id, b.fee, b.consultation_fee, b.coupon_id, b.coupon_percentage, b.coupon_discount, b.payment_type, b.patient_name, b.booking_status, s.name AS specialization, d.name AS doctor_name, d.exp, COUNT(b.id) AS consultations, GROUP_CONCAT(DISTINCT md.name ORDER BY md.name SEPARATOR ", ") AS qualification,fm.email, fm.gender, fm.dob, d.image, bg.name as blood_group');

    $this->db->from('doctor_bookings b');
    $this->db->join('specialities s', 's.id = b.speciality_id', 'left');
    $this->db->join('doctors d', 'd.id = b.doctor_id', 'left');
    $this->db->join('family_members fm', 'fm.id = b.family_member_id', 'left');
    $this->db->join('blood_groups bg', 'bg.id = fm.blood_group', 'left');
    $this->db->join('medical_degrees md', 'FIND_IN_SET(md.id, d.qualification)', 'left');
    $this->db->where('b.booking_id', $booking_id);
    //$this->db->where('b.booking_status', 'completed');
    $this->db->group_by('b.id');
    $this->db->order_by('b.id', 'DESC');
    //$this->db->limit($limit, $offset);

    $query = $this->db->get();
    $result = $query->result_array();

    $final_result = [];

    foreach ($result as $row) {
        $booking_id = $row['booking_id'];

        // Fetch medicines
        $medicines = $this->db
        ->select('medicine, medicine_time')
        ->get_where('doctor_booking_medicines', ['booking_id' => $booking_id])
        ->result_array();

        
        // Fetch tests
        $tests = $this->db
        ->select('test, test_instruction')
        ->get_where('doctor_booking_tests', ['booking_id' => $booking_id])
        ->result_array();
        
        // Fetch notes
        
        $notes = $this->db
            ->select('notes')
            ->get_where('doctor_booking_notes', ['booking_id' => $booking_id])
            ->result_array();
        
        // Extract just the 'notes' values into a simple array
        $note_values = array_column($notes, 'notes');
        
        // Assign directly to your output array
        $data = $note_values;

        $final_result[] = [
            'id'                => intval($row['id']),
            'booking_id'        => $row['booking_id'],
            'consult_type'      => $row['consult_type'],
            'user_id'           => intval($row['user_id']),
            'speciality_id'     => intval($row['speciality_id']),
            'doctor_id'         => intval($row['doctor_id']),
            'slot_id'           => intval($row['slot_id']),
            'time'              => $row['time'],
            'date'              => date('d-m-Y', strtotime($row['date'])),
            'mobile'            => intval($row['mobile']),
            'call_status'       => intval($row['call_status']),
            'family_member_id'  => intval($row['family_member_id']),
            'fee'               => intval($row['fee']),
            'consultation_fee'  => intval($row['consultation_fee']),
            'coupon_id'         => intval($row['coupon_id']),
            'coupon_percentage' => intval($row['coupon_percentage']),
            'coupon_discount'   => intval($row['coupon_discount']),
            'payment_type'      => $row['payment_type'],
            'specialization'    => $row['specialization'],
            'name'              => $row['doctor_name'],
            'exp'               => intval($row['exp']),
            'consultations'     => intval($row['consultations']),
            'qualification'     => $row['qualification'],
            'image'             => $row['image'],
            'booking_status'    => $row['booking_status'],
            'patient_name'      => $row['patient_name'],
            'email'             => $row['email'],
            'gender'            => $row['gender'],
            'dob'               => $row['dob'],
            'blood_group'       => $row['blood_group'],
            'medicines'         => !empty($medicines) ? $medicines : [],
            'tests'             => !empty($tests) ? $tests : [],
            'notes'             => !empty($notes) ? $data : []
        ];
    }

    return $final_result;
}
/*hospital_doctor_module*/

/*hospital_bookings*/
public function ambulance_bookings_ongoing($user_id, $limit, $offset) {
    $this->db->select('
        db.id,
        db.booking_id,
        db.created_on,
        db.user_id,
        db.main_data_id,
        db.booking_status,
        db.name,
        db.mobile,
        db.accept_status,
        db.trip_status,
        db.address_id,
        d.name as hospital_name,
        d.logo,
        db.date,
        d.open_time,
        d.close_time,
        d.location,
        IFNULL(pra.name, "") AS ambulance_driver_name,
        IFNULL(pra.image, "") AS ambulance_driver_image,
        IFNULL(pra.mobile, 0) AS ambulance_driver_mobile,
        IFNULL(pra.vehicle_number, "") AS vehicle_number,
        c.name as tagline,
        ua.hno,
        ua.colony,
        ua.pincode,
        ua.state,
        ua.landmark,
        ua.address_type,
        ua.default_address,
        ua.lat,
        ua.lon
    ');
    $this->db->from('ambulance_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'booked');
    $this->db->join('main_data d', 'd.id = db.main_data_id', 'left');
    $this->db->join('categories c', 'c.id = d.cat_id', 'left');
    $this->db->join('ambulance_drivers pra', 'pra.id = db.ambulance_driver_id', 'left');
    $this->db->join('user_addresses ua', 'ua.id = db.address_id', 'left');
    $this->db->limit($limit, $offset);
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        return [
            'id'                            => intval($row['id']),
            'booking_id'                    => $row['booking_id'],
            'created_on'                    => $row['created_on'],
            'user_id'                       => intval($row['user_id']),
            'hospital_id'                   => intval($row['main_data_id']),
            'hospital_name'                 => $row['hospital_name'],
            'logo'                          => $row['logo'],
            'open_time'                     => $row['open_time'],
            'close_time'                    => $row['close_time'],
            'location'                      => $row['location'],
            'booking_status'                => $row['booking_status'],
            'name'                          => $row['name'],
            'mobile'                        => intval($row['mobile']),
            'accept_status'                 => $row['accept_status'],
            'trip_status'                   => $row['trip_status'],
            //'slot_id'                     => intval($row['slot_id']),
            'date'                          => $row['date'],
            'ambulance_driver_name'         => $row['ambulance_driver_name'],
            'ambulance_driver_image'        => $row['ambulance_driver_image'],
            'ambulance_driver_mobile'       => intval($row['ambulance_driver_mobile']),
            'vehicle_number'                => $row['vehicle_number'],
            'tagline'                       => $row['tagline'],
            'pick_up_location'              => [
                                                    'hno'               => $row['hno'],
                                                    'colony'            => $row['colony'],
                                                    'pincode'           => intval($row['pincode']),
                                                    'state'             => $row['state'],
                                                    'landmark'          => $row['landmark'],
                                                    'address_type'      => $row['address_type'],
                                                    'lat'               => $row['lat'],
                                                    'lon'               => $row['lon'],
                                                    'default_address'   => intval($row['default_address'])
                                                ]
        ];
    }, $result);
}
public function ambulance_bookings_ongoing_rows($user_id){
    $this->db->from('ambulance_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'booked');
    return $this->db->count_all_results();
}
public function ambulance_bookings_completed($user_id, $limit, $offset) {
    $this->db->select('
        db.id,
        db.booking_id,
        db.created_on,
        db.user_id,
        db.main_data_id,
        db.booking_status,
        db.name,
        db.mobile,
        db.accept_status,
        db.trip_status,
        d.name as hospital_name,
        d.logo,
        db.date,
        d.open_time,
        d.close_time,
        d.location,
        IFNULL(pra.name, "") AS ambulance_driver_name,
        IFNULL(pra.image, "") AS ambulance_driver_image,
        IFNULL(pra.mobile, 0) AS ambulance_driver_mobile,
        IFNULL(pra.vehicle_number, "") AS vehicle_number,
        c.name as tagline,
        ua.hno,
        ua.colony,
        ua.pincode,
        ua.state,
        ua.landmark,
        ua.address_type,
        ua.default_address,
        ua.lat,
        ua.lon
    ');
    $this->db->from('ambulance_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'completed');
    $this->db->join('main_data d', 'd.id = db.main_data_id', 'left');
    $this->db->join('categories c', 'c.id = d.cat_id', 'left');
    $this->db->join('ambulance_drivers pra', 'pra.id = db.ambulance_driver_id', 'left');
    $this->db->join('user_addresses ua', 'ua.id = db.address_id', 'left');
    $this->db->limit($limit, $offset);
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        return [
            'id'                            => intval($row['id']),
            'booking_id'                    => $row['booking_id'],
            'created_on'                    => $row['created_on'],
            'user_id'                       => intval($row['user_id']),
            'hospital_id'                   => intval($row['main_data_id']),
            'hospital_name'                 => $row['hospital_name'],
            'logo'                          => $row['logo'],
            'open_time'                     => $row['open_time'],
            'close_time'                    => $row['close_time'],
            'location'                      => $row['location'],
            'booking_status'                => $row['booking_status'],
            'name'                          => $row['name'],
            'mobile'                        => intval($row['mobile']),
            'accept_status'                 => $row['accept_status'],
            'trip_status'                   => $row['trip_status'],
            //'slot_id'                     => intval($row['slot_id']),
            'date'                          => $row['date'],
            'ambulance_driver_name'         => $row['ambulance_driver_name'],
            'ambulance_driver_image'        => $row['ambulance_driver_image'],
            'ambulance_driver_mobile'       => intval($row['ambulance_driver_mobile']),
            'vehicle_number'                => $row['vehicle_number'],
            'tagline'                       => $row['tagline'],
            'pick_up_location'              => [
                                                    'hno'               => $row['hno'],
                                                    'colony'            => $row['colony'],
                                                    'pincode'           => intval($row['pincode']),
                                                    'state'             => $row['state'],
                                                    'landmark'          => $row['landmark'],
                                                    'address_type'      => $row['address_type'],
                                                    'lat'               => $row['lat'],
                                                    'lon'               => $row['lon'],
                                                    'default_address'   => intval($row['default_address'])
                                                ]
        ];
    }, $result);
}
public function ambulance_bookings_completed_rows($user_id){
    $this->db->from('ambulance_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'completed');
    return $this->db->count_all_results();
}
public function get_hospital_dates($main_data_id){
    $today = date('Y-m-d');

    $this->db->select('DISTINCT(date)', false);
    $this->db->from('hospital_slots');
    //$this->db->where('cat_id', $cat_id);
    $this->db->where('main_data_id', $main_data_id);
    $this->db->where('date >=', $today);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);
    $this->db->order_by('date', 'ASC');
    
    $query = $this->db->get();
    $result = $query->result_array();

    // Format the dates
    $dates = array_map(function($row) {
        return [
            'date' => $row['date'],
            'format_date' => date('D d M', strtotime($row['date']))
        ];
    }, $result);

    return $dates;
}
public function get_hospital_slots($main_data_id,$date,$user_id) {
    /*$today = date('Y-m-d');
    $current_time_24hr = date('H:i');

    $this->db->select('id, time, session, booking_status, date');
    $this->db->from('hospital_slots');
    $this->db->where('main_data_id', $main_data_id);
    $this->db->where('date', $date);
    $this->db->where('status', 1);
    $this->db->where('delete_status', 1);

    // Filter only future slots if date is today
    if ($date == $today) {
        $this->db->where("STR_TO_DATE(time, '%h:%i %p') >=", $current_time_24hr);
    }

    $this->db->order_by("STR_TO_DATE(time, '%h:%i %p')", "ASC", false);

    $query = $this->db->get();
    $raw_slots = $query->result_array();

    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    $added_times = []; // To avoid duplicates

    foreach ($raw_slots as $row) {
        $time_24hr = date('H:i', strtotime($row['time']));
        if (in_array($row['time'], $added_times)) continue; // prevent duplicates
        $added_times[] = $row['time'];

        $row['id'] = (int)$row['id'];
        $row['format_date'] = date('d M Y', strtotime($row['date']));

        if ($time_24hr >= 0 && $time_24hr < 12) {
            $slots['morning'][] = $row;
        } elseif ($time_24hr >= 12 && $time_24hr < 17) {
            $slots['afternoon'][] = $row;
        } else {
            $slots['evening'][] = $row;
        }
    }*/

    // Fetch family members
    $this->db->select('id, name, type, mobile');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    foreach ($family_members as &$member) {
        $member['id']       = intval($member['id']);
        $member['mobile']   = intval($member['mobile']);
    }

    return $family_members;
}
public function get_admit_slots($cat_id,$main_data_id,$date,$user_id){
    // Fetch doctor slots
    $this->db->select('id, time, session, status, date');
    $this->db->from('admit_slots');
    $this->db->where('cat_id', $cat_id);
    $this->db->where('main_data_id', $main_data_id);
    $this->db->where('date', $date);
    $this->db->order_by('time', 'ASC');

    $query = $this->db->get();
    $results = $query->result_array();

    // Group slots by session
    $slots = ['morning' => [], 'afternoon' => [], 'evening' => []];
    foreach ($results as $row) {
        $row['id']          = intval($row['id']); // Convert slot ID to int
        $row['format_date'] = date('d M Y', strtotime($row['date']));
        $slots[$row['session']][] = $row;
    }

    // Fetch family members separately
    $this->db->select('id, name, type');
    $this->db->from('family_members');
    $this->db->where('user_id', $user_id);  // Fetch family members of the logged-in user
    $family_query = $this->db->get();
    $family_members = $family_query->result_array();

    // Convert family member IDs to integers
    foreach ($family_members as &$member) {
        $member['id'] = intval($member['id']);  // Ensure id is an integer
    }

    // Return both doctor slots and family members in a single response
    return [
        'slots' => $slots,
        'family_members' => $family_members
    ];
}
public function admit_bookings_ongoing($user_id, $limit, $offset){
    $this->db->select('db.id,db.booking_id,db.created_on,db.user_id,db.main_data_id,db.booking_status,d.name as hospital_name,d.logo,db.date,db.time,d.open_time,d.close_time,d.location,IFNULL(pra.name, "") AS pr_name,IFNULL(pra.image, "") AS pr_image,IFNULL(pra.mobile, 0) AS pr_mobile,c.name as tagline');
    $this->db->from('admit_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'booked');

    $this->db->join('main_data d','d.id=db.main_data_id','left');
    $this->db->join('categories c','c.id=d.cat_id','left');
    $this->db->join('pr_agents pra','pra.id=db.pr_id','left');
    $this->db->limit($limit, $offset);
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'hospital_id' => intval($row['main_data_id']),
            'name' => $row['hospital_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'booking_status' => $row['booking_status'],
            //'booking_type'      => $row['booking_type'],
            //'slot_id' => intval($row['slot_id']),
            'date'      => $row['date'],
            'time'      => $row['time'],
            "pr_name"   => $row['pr_name'],
            "pr_image"  => $row['pr_image'],
            'pr_mobile' => intval($row['pr_mobile']),
            'tagline'   => $row['tagline']
        ];
    }, $result);
}
public function admit_bookings_ongoing_rows($user_id){
    $this->db->from('admit_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'booked');
    return $this->db->count_all_results();
}
public function admit_bookings_completed($user_id, $limit, $offset){
    $this->db->select('db.id,db.booking_id,db.created_on,db.user_id,db.main_data_id,db.booking_status,d.name as hospital_name,d.logo,db.date,db.time,d.open_time,d.close_time,d.location,IFNULL(pra.name, "") AS pr_name,IFNULL(pra.image, "") AS pr_image,IFNULL(pra.mobile, 0) AS pr_mobile,c.name as tagline');
    $this->db->from('admit_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'completed');

    $this->db->join('main_data d','d.id=db.main_data_id','left');
    $this->db->join('categories c','c.id=d.cat_id','left');
    $this->db->join('pr_agents pra','pra.id=db.pr_id','left');
    $this->db->limit($limit, $offset);
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $result = $query->result_array();

    return array_map(function ($row) {
        return [
            'id' => intval($row['id']),
            'booking_id'    => $row['booking_id'],
            'created_on'    => $row['created_on'],
            'user_id' => intval($row['user_id']),
            'hospital_id' => intval($row['main_data_id']),
            'name' => $row['hospital_name'],
            'logo' => $row['logo'],
            'open_time' => $row['open_time'],
            'close_time' => $row['close_time'],
            'location' => $row['location'],
            'booking_status' => $row['booking_status'],
            //'booking_type'      => $row['booking_type'],
            //'slot_id' => intval($row['slot_id']),
            'date'      => $row['date'],
            'time'      => $row['time'],
            "pr_name"   => $row['pr_name'],
            "pr_image"   => $row['pr_image'],
            'pr_mobile' => intval($row['pr_mobile']),
            'tagline'   => $row['tagline']
        ];
    }, $result);
}
public function admit_bookings_completed_rows($user_id){
    $this->db->from('admit_bookings db');
    $this->db->where('db.user_id', $user_id);
    $this->db->where('db.booking_status', 'completed');
    return $this->db->count_all_results();
}
public function single_admit_booking_details($booking_id){
    // Step 1: Fetch booking details
    $this->db->select('
        db.id, db.booking_id, db.created_on, db.user_id, db.main_data_id,
        db.booking_status, d.name as hospital_name, d.logo,  db.date, db.time,
        d.open_time, d.close_time, d.location, c.name as tagline, db.family_member_id,
        IFNULL(pra.name, "") AS pr_name,
        IFNULL(pra.image, "") AS pr_image,
        IFNULL(pra.mobile, 0) AS pr_mobile
    ');
    $this->db->from('admit_bookings db');
    $this->db->join('main_data d', 'd.id = db.main_data_id', 'left');
    $this->db->join('categories c', 'c.id = d.cat_id', 'left');
    $this->db->join('pr_agents pra', 'pra.id = db.pr_id', 'left');
    $this->db->where('db.booking_id', $booking_id);
    $this->db->order_by('db.id', 'DESC');

    $query = $this->db->get();
    $results = $query->result_array();

    if (empty($results)) return null;

    // Step 2: Get booking reports
    $this->db->select('image');
    $this->db->from('admit_booking_reports');
    $this->db->where('booking_id', $booking_id);
    $reports = $this->db->get()->result_array();

    // Step 3: Extract family member IDs from results
    $family_member_ids = [];

    foreach ($results as $row) {
        if (!empty($row['family_member_id'])) {
            $ids = explode(',', $row['family_member_id']);
            foreach ($ids as $id) {
                $clean_id = intval(trim($id));
                if ($clean_id > 0) {
                    $family_member_ids[] = $clean_id;
                }
            }
        }
    }

    $family_members = [];
    $family_member_ids = array_unique($family_member_ids);

    if (!empty($family_member_ids)) {
        $this->db->select('id, name, dob, gender, email, mobile');
        $this->db->from('family_members');
        $this->db->where_in('id', $family_member_ids);
        $family_members = $this->db->get()->result_array();
    }

    // Step 4: Map final response
    return array_map(function ($row) use ($reports, $family_members) {
        return [
            'id'              => intval($row['id']),
            'booking_id'      => $row['booking_id'],
            'created_on'      => $row['created_on'],
            'user_id'         => intval($row['user_id']),
            'hospital_id'     => intval($row['main_data_id']),
            'name'            => $row['hospital_name'],
            'logo'            => $row['logo'],
            'tagline'         => $row['tagline'],
            'open_time'       => $row['open_time'],
            'close_time'      => $row['close_time'],
            'location'        => $row['location'],
            'booking_status'  => $row['booking_status'],
            //'slot_id'         => intval($row['slot_id']),
            'date'            => $row['date'],
            'time'            => $row['time'],
            'pr_name'         => $row['pr_name'],
            'pr_image'        => $row['pr_image'],
            'pr_mobile'       => intval($row['pr_mobile']),
            'reports'         => $reports,
            'family_members'  => $family_members
        ];
    }, $results);
}
/*hospital_bookings*/

/*health cards*/
public function get_health_cards($user_id){
    $this->db->select('health_card_holders.*,family_members.name as family_members_name,family_members.image as family_members_image,family_members.type')->from('health_card_holders');
    $this->db->where('health_card_holders.user_id',$user_id);
    $this->db->join('family_members','family_members.id=health_card_holders.family_id','left');
    $query = $this->db->get();
    return $query->result_array();
}
/*health cards*/

/*offers*/
public function get_main_data_offers($lat, $lon, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
        main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    

    // Filters
    $this->db->where('main_data.offers', 'yes');
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    
    return $result;

}
public function get_search_main_data_offers($lat, $lon, $search, $radius){
    $this->db->select("
        COALESCE(( 6371 * acos( cos( radians({$lat}) ) * cos( radians( `lat` ) ) * cos( radians( lon ) - radians({$lon}) ) + sin( radians({$lat}) ) * sin( radians( `lat` ) ) ) ), 0) AS distance, 
       main_data.id,main_data.cat_id,main_data.name,main_data.tagline,main_data.logo,main_data.location,main_data.lat,main_data.lon", false);
    $this->db->from('main_data');
    

    // Filters
    $this->db->where('main_data.offers', 'yes');
    $this->db->where('main_data.status', 1);
    $this->db->where('main_data.delete_status', 1);
    $this->db->like('main_data.name',$search);

    // Distance Filter
    $this->db->having('distance <=', $radius);

    // Grouping
    $this->db->group_by('main_data.id');
    $this->db->order_by('distance', 'asc');

    $query = $this->db->get();
    $result = $query->result_array();
    
    
    return $result;

}
/*offers*/

/*executive_app_apis*/
public function executive_sales($executive_id){
    $this->db->select('executive_sales_completed.*,users.id as user_id,users.name,users.image,users.gender,users.mobile,executives.executive_id as unique_id')->from('executive_sales_completed');
    $this->db->where('executive_sales_completed.executive_id',$executive_id);
    $this->db->join('users','users.id=executive_sales_completed.user_id','left');
    $this->db->join('executives','executives.id=executive_sales_completed.executive_id','left');
    $query = $this->db->get();
    $result = $query->result_array();
    return $result;
}
public function search_executive_sales($search, $executive_id) {
    $this->db->select('executive_sales_completed.*, users.name, users.image, users.gender, users.mobile, executives.executive_id as unique_id');
    $this->db->from('executive_sales_completed');
    $this->db->join('users', 'users.id = executive_sales_completed.user_id', 'left');
    $this->db->join('executives', 'executives.id = executive_sales_completed.executive_id', 'left');

    // Add search condition for the users.name column
    $this->db->like('users.name', $search);

    // Add condition for executive_id
    $this->db->where('executive_sales_completed.executive_id', $executive_id);

    $query = $this->db->get();
    $result = $query->result_array();
    return $result;
}

/*executive_app_apis*/

}
?>